/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Metal4kde.h"
#include "bitmaps.h"
#include "embeddata.h"





/****************************************************************************/
/****** class meatal                                                  *******/
/****************************************************************************/


/******************/
/* public         */
/******************/

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// Constructor

Metal4kdeStyle::Metal4kdeStyle()
        : KStyle( FilledFrameWorkaround | AllowMenuTransparency,
                  ThreeButtonScrollBar )
{
#ifdef BACKTRACE
    qWarning( "Metal4kdeStyle()" );
#endif

    progAnimShift_ = 0;
    scrollBarAnimShift_ = 5;
    scrollBarStartNum_ = 120;
    scrollBarMovementmShift_ == 30;
    headerHoverID_ = -1;
    qtrcModificationTime_ = 0;
    reverse_ = QApplication::reverseLayout();
    kicker_ = FALSE;
    konqueror_ = FALSE;
    kdesktop_ = FALSE;
    isHTMLButton_ = FALSE;
    shouldColorize_ = FALSE;
    initialPaletteLoaded_ = FALSE;
    hover_ = NULL;
    btnOffset_= QPoint(0,0);
    currentScrollBar_ = NULL;
    rMatrix_.rotate( 90.0 );
    iMatrix_.rotate( 180.0 );
    scrollBarTimer_ = NULL;
    optionsHandler_ = new optionsHandler( this );
    tooltipPalette_ = qApp->palette();

    btnDict_.setAutoDelete( TRUE );
    btnWebDict_.setAutoDelete( TRUE );
    clearFillSmallDict_.setAutoDelete( TRUE );
    clearFillLargeDict_.setAutoDelete( TRUE );
    verScrollBarTopDict_.setAutoDelete( TRUE );
    verScrollBarMidDict_.setAutoDelete( TRUE );
    verScrollBarBtmDict_.setAutoDelete( TRUE );
    horScrollBarTopDict_.setAutoDelete( TRUE );
    horScrollBarMidDict_.setAutoDelete( TRUE );
    horScrollBarBtmDict_.setAutoDelete( TRUE );
    animationWidgetDict_.setAutoDelete( TRUE );

    // create special images
    buttonImg_ = new QImage( uic_findImage( "button" ) );
    if ( buttonImg_->depth() < 32 )
        * buttonImg_ = buttonImg_->convertDepth( 32 );

    buttonWebImg_ = new QImage( uic_findImage( "buttonWeb" ) );
    if ( buttonWebImg_->depth() < 32 )
        * buttonWebImg_ = buttonWebImg_->convertDepth( 32 );

    QImage *brushedMetalImg_ = new QImage( uic_findImage( "brushedMetal" ) );
    if ( brushedMetalImg_->depth() < 32 )
        * brushedMetalImg_ = brushedMetalImg_->convertDepth( 32 );
    brushedMetalPix_ = adjustHSV(*brushedMetalImg_ ,optionsHandler_->customColors_[CustomBrushedMetal], FALSE );

    QImage *brushedMetalLightningImg_ = new QImage( uic_findImage( "light" ) );
    if ( brushedMetalLightningImg_->depth() < 32 )
        * brushedMetalLightningImg_ = brushedMetalLightningImg_->convertDepth( 32 );
    brushedMetalLightningPix_ = new QPixmap();
    brushedMetalLightningPix_->convertFromImage( *brushedMetalLightningImg_ );

    editBoxImg_ = new QImage( uic_findImage( "editBox" ) );
    if ( editBoxImg_->depth() < 32 )
        * editBoxImg_ = editBoxImg_->convertDepth( 32 );

    clearFillLargeImg_ = new QImage( uic_findImage( "clearFillLarge" ) );
    if ( clearFillLargeImg_->depth() < 32 )
        * clearFillLargeImg_ = clearFillLargeImg_->convertDepth( 32 );

    clearFillSmallImg_ = new QImage( uic_findImage( "clearFillSmall" ) );
    if ( clearFillSmallImg_->depth() < 32 )
        * clearFillSmallImg_ = clearFillSmallImg_->convertDepth( 32 );

    QImage *menuLeftImg_ = new QImage( uic_findImage( "menuLeft" ) );
    if ( menuLeftImg_->depth() < 32 )
        * menuLeftImg_ = menuLeftImg_->convertDepth( 32 );
    menuLeftPix_ = new QPixmap();
    menuLeftPix_->convertFromImage( *menuLeftImg_ );

    QImage *menuRightImg = new QImage( uic_findImage( "menuRight" ) );
    if ( menuRightImg->depth() < 32 )
        * menuRightImg = menuRightImg->convertDepth( 32 );
    menuRightPix_ = new QPixmap();
    menuRightPix_->convertFromImage( *menuRightImg );

    verScrollBarTopImg_ = new QImage( uic_findImage( "sbslider_top" ) );
    if ( verScrollBarTopImg_->depth() < 32 )
        * verScrollBarTopImg_ = verScrollBarTopImg_->convertDepth( 32 );

    verScrollBarMidImg_ = new QImage( uic_findImage( "sbslider_mid" ) );
    if ( verScrollBarMidImg_->depth() < 32 )
        * verScrollBarMidImg_ = verScrollBarMidImg_->convertDepth( 32 );

    verScrollBarBtmImg_ = new QImage( uic_findImage( "sbslider_btm" ) );
    if ( verScrollBarBtmImg_->depth() < 32 )
        * verScrollBarBtmImg_ = verScrollBarBtmImg_->convertDepth( 32 );

    horScrollBarTopImg_ = new QImage();
    *horScrollBarTopImg_ = verScrollBarBtmImg_->xForm( rMatrix_ );

    horScrollBarMidImg_ = new QImage();
    *horScrollBarMidImg_ = verScrollBarMidImg_->xForm( rMatrix_ );

    horScrollBarBtmImg_ = new QImage();
    *horScrollBarBtmImg_ = verScrollBarTopImg_->xForm( rMatrix_ );

    // init pixmap
    for ( int i = 0; i < BitmapDataCount; i++ )
    {
        pixmaps_[ i ] = NULL;
    }


    // create static bitmaps
    uarrow = QBitmap( 6, 6, uarrow_bits, true );
    uarrow.setMask( uarrow );
    darrow = QBitmap( 6, 6, darrow_bits, true );
    darrow.setMask( darrow );
    larrow = QBitmap( 6, 6, larrow_bits, true );
    larrow.setMask( larrow );
    rarrow = QBitmap( 6, 6, rarrow_bits, true );
    rarrow.setMask( rarrow );
    bplus = QBitmap( 6, 6, bplus_bits, true );
    bplus.setMask( bplus );
    bminus = QBitmap( 6, 6, bminus_bits, true );
    bminus.setMask( bminus );
    bcheck = QBitmap( 9, 9, bcheck_bits, true );
    bcheck.setMask( bcheck );
    dexpand = QBitmap( 9, 9, dexpand_bits, true );
    dexpand.setMask( dexpand );
    rexpand = QBitmap( 9, 9, rexpand_bits, true );
    rexpand.setMask( rexpand );
    doodad_mid = QBitmap( 4, 4, doodad_mid_bits, true );
    doodad_light = QBitmap( 4, 4, doodad_light_bits, true );

    QTimer* timer = new QTimer( this );
    //timer->start( 50, false );
    //connect( timer, SIGNAL( timeout() ), this, SLOT( updateProgressPos() ) );
}

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// destructor

Metal4kdeStyle::~Metal4kdeStyle()
{
#ifdef BACKTRACE
    qWarning( "~Metal4kdeStyle()" );
#endif


    // clear out all old colorized pixmaps_
    for ( int i = 0; i < BitmapDataCount; ++i )
    {
        if ( pixmaps_[ i ] )
        {
            delete pixmaps_[ i ];
            pixmaps_[ i ] = NULL;
        }
    }

    // clear out all dicts
    btnDict_.clear();
    btnWebDict_.clear();
    clearFillSmallDict_.clear();
    clearFillLargeDict_.clear();
    verScrollBarTopDict_.clear();
    verScrollBarMidDict_.clear();
    verScrollBarBtmDict_.clear();
    horScrollBarTopDict_.clear();
    horScrollBarMidDict_.clear();
    horScrollBarBtmDict_.clear();

    // clear option handler
    if ( optionsHandler_ )
        delete optionsHandler_;

    // clear out all style images and pix
    if ( buttonImg_ )
        delete buttonImg_;

    if ( brushedMetalPix_ )
        delete brushedMetalPix_;

    if ( verScrollBarTopImg_ )
        delete verScrollBarTopImg_;

    if ( verScrollBarMidImg_ )
        delete verScrollBarMidImg_;

    if ( verScrollBarBtmImg_ )
        delete verScrollBarBtmImg_;

    if ( horScrollBarTopImg_ )
        delete horScrollBarTopImg_;

    if ( horScrollBarMidImg_ )
        delete horScrollBarMidImg_;

    if ( horScrollBarBtmImg_ )
        delete horScrollBarBtmImg_;
}



//////////////////////////////////////////////////////////////////////////////
// drawPrimitive()
// ---------------
// Draw the primitive element

void Metal4kdeStyle::drawPrimitive( PrimitiveElement element,
                                    QPainter *painter,
                                    const QRect &rect,
                                    const QColorGroup &group,
                                    SFlags flags,
                                    const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawPrimitive() called" );
#endif


    // common locals
    bool down = flags & Style_Down;
    bool on = flags & Style_On;
    bool depress = ( down || on );
    bool enabled = flags & Style_Enabled;
    bool off = flags & Style_Off;
    bool horiz = flags & Style_Horizontal;
    bool mouseover = ( flags & Style_MouseOver );
    int x, y, w, h, x2, y2;
    QPointArray parray;
    QWidget* widget;



    rect.rect( &x, &y, &w, &h );

    x2 = rect.right();
    y2 = rect.bottom();

    switch ( element )
    {
    case PE_ButtonBevel:
    case PE_ButtonDropDown:
    case PE_ButtonTool:

        drawClearBevel( painter, x, y, w, h, group.button() );
        break;

    case PE_ButtonCommand:
    case PE_ButtonDefault:
        {
            QColor col = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOff ] : group.background();
            QColor hoverCol = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOn ] : group.button();

            drawMetalButton( painter, x, y, w, h, group, mouseover ? hoverCol : col, isHTMLButton_, depress, btnOffset_.x(), btnOffset_.y() );
            break;
        }

    case PE_FocusRect:
        {
            painter->drawWinFocusRect( rect );
            break;
            break;
        }

    case PE_HeaderSection:
        {
            // covers kicker taskbar buttons and menu titles
            QHeader* header = dynamic_cast<QHeader*>( painter->device() );
            widget = dynamic_cast<QWidget*>( painter->device() );

            if ( header )
            {
                horiz = ( header->orientation() == Horizontal );
            }
            else
            {
                horiz = true;
            }

            if ( ( widget ) && ( ( widget->inherits( "QPopupMenu" ) ) ||
                                 ( widget->inherits( "KPopupTitle" ) ) ) )
            {
                // kicker/kdesktop menu titles
                //                 drawMetal4kdeBevel( painter, x, y, w, h,
                //                                 group, group.background(), depress, !horiz );
                drawClearBevel( painter, x, y, w, h, group.button(), TRUE );
            }
            else if ( kicker_ )
            {
                // taskbar buttons (assuming no normal headers used in kicker)
                if ( depress )
                {
                    drawClearBevel( painter, x, y, w, h, group.button() );
                }
                else
                {
                    drawClearBevel( painter, x, y, w, h, group.background() );
                }
            }
            else
            {
                bool hover = FALSE;
                if ( currentHeader_ == painter->device() )
                {
                    int id = currentHeader_->sectionAt( rect.x() + ( ( QHeader* ) painter->device() ) ->offset() );
                    hover = id != -1 && id == headerHoverID_;
                    //                     qWarning( "id - %d!", id );
                    //                     qWarning( "headerHoverID_ - %d", headerHoverID_ );
                }
                drawClearBevel( painter, x, y, w, h, hover ? group.button() : group.background() );
            }
            break;
        }

    case PE_HeaderArrow:
        if ( flags & Style_Up )
            drawPrimitive( PE_ArrowUp, painter, rect, group, Style_Enabled );
        else
            drawPrimitive( PE_ArrowDown, painter, rect, group, Style_Enabled );
        break;

    case PE_ScrollBarAddPage:
    case PE_ScrollBarSubPage:
    case PE_ScrollBarSlider:
        {
            QColor sbBgColor = qApp->palette().active().background();
            QColor c = qApp->palette().active().background();
            //QPixmap *bgPix = horiz ? getPixmap( HclearFillLargeBackgroundColor, group ) : getPixmap( VclearFillLargeBackgroundColor, group );
            Metal4kdeStyle * ptr = const_cast<Metal4kdeStyle*>( this );

            bool isHover;
            isHover = hover_ == currentScrollBar_;

            if ( horiz )
            {
                int extent = currentScrollBar_->height();
                QRect bgR( extent, 0, currentScrollBar_->width() - extent * 3 + 1, extent );

                if ( sbBuffer_.size() != currentScrollBar_->size() )
                    const_cast<Metal4kdeStyle*>( this ) ->sbBuffer_.resize( currentScrollBar_->size() );

                QPainter p;
                p.begin( &sbBuffer_ );

                //draw scroll bar background
                // top
                p.fillRect(bgR.right() - 10 , bgR.y() + 1, 10, 13, qApp->palette().active().background());
                p.drawPixmap( bgR.right() - 10 , bgR.y() + 1, *getPixmap( HSBSliderTopBg ) );
                // mid
                p.drawTiledPixmap( bgR.x() + 10, bgR.y() + 1, bgR.width() - 20, 13, *getPixmap( HSBSliderMidBg ) );
                // bottom
                p.fillRect(bgR.x(), bgR.y() + 1, 10, 13, qApp->palette().active().background());
                p.drawPixmap( bgR.x(), bgR.y() + 1, *getPixmap( HSBSliderBtmBg ) );



                if ( element == PE_ScrollBarSlider )
                {
                    if ( isHover )
                    {
                        QColor scrollCol = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOn ] : group.button();
                        QColor col = scrollCol.light( scrollBarStartNum_ );
                        QColor scrollBarBg = Qt::gray;

                        //top
                        QPixmap *topPix = horScrollBarTopDict_.find( col.rgb() );
                        if ( !topPix )
                        {
                            topPix = adjustHSV( *horScrollBarTopImg_, col, FALSE );
                            if ( topPix )
                                ptr->horScrollBarTopDict_.insert( col.rgb(), topPix );
                        }
                        if ( !topPix )
                        {
                            //qWarning( "topPix is NULL!" );
                            return ;
                        }
                        p.drawPixmap( rect.x(), rect.y() + 1, *topPix );

                        //btm
                        QPixmap *btmPix = horScrollBarBtmDict_.find( col.rgb() );

                        if ( !btmPix )
                        {
                            btmPix = adjustHSV( *horScrollBarBtmImg_, col, FALSE );
                            if ( btmPix )
                                ptr->horScrollBarBtmDict_.insert( col.rgb(), btmPix );
                        }
                        if ( !btmPix )
                        {
                            //qWarning( "btmPix is NULL!" );
                            return ;
                        }
                        p.drawPixmap( rect.right() - 3, rect.y() + 1, *btmPix );

                        //mid
                        QPixmap *midPix = horScrollBarMidDict_.find( col.rgb() );
                        if ( !midPix )
                        {
                            midPix = adjustHSV( *horScrollBarMidImg_, col, FALSE );
                            if ( midPix )
                                ptr->horScrollBarMidDict_.insert( col.rgb(), midPix );
                        }
                        if ( !midPix )
                        {
                            //qWarning( "midPix is NULL!" );
                            return ;
                        }
                        p.setClipRect(rect.x() + 3, rect.y() + 1, rect.width() - 6, 13, QPainter::CoordPainter);
                        p.drawTiledPixmap( rect.x() + 3 - scrollBarMovementmShift_, rect.y() + 1, rect.width() - 6 + scrollBarMovementmShift_, 13, *midPix );
                    }
                    else
                    {
                        //top
                        p.drawPixmap( rect.x(), rect.y() + 1, *getPixmap( HSBSliderBtm ) );
                        //mid
                        p.drawTiledPixmap( rect.x() + 3, rect.y() + 1, rect.width() -6, 13, *getPixmap( HSBSliderMid ) );
                        //btm
                        p.drawPixmap( rect.right() - 3, rect.y() + 1, *getPixmap( HSBSliderTop ) );

                    }

                }
                p.setPen( QColor(140,140,140) );
                p.drawLine( bgR.x(), bgR.y(), bgR.right(), bgR.y() );
                p.drawLine( bgR.x(), bgR.bottom(), bgR.right(),
                            bgR.bottom() );
                p.end();
            }
            else
            {
                int extent = currentScrollBar_->width();
                QRect bgR( 0, extent, extent, currentScrollBar_->height() - extent * 3 );


                if ( sbBuffer_.size() != currentScrollBar_->size() )
                    const_cast<Metal4kdeStyle*>( this ) ->sbBuffer_.resize( currentScrollBar_->size() );

                QPainter p;
                p.begin( &sbBuffer_ );

                p.fillRect(bgR.x() + 1, bgR.y(),13,bgR.height(),qApp->palette().active().background() );

                //draw scroll bar background
                // top
                p.fillRect(bgR.x() + 1, bgR.y(),13,10,qApp->palette().active().background() );
                p.drawPixmap( bgR.x() + 1 , bgR.y(), *getPixmap( VSBSliderTopBg ) );
                // mid
                p.drawTiledPixmap( bgR.x() + 1, bgR.y() + 10, 13, bgR.height() - 20, *getPixmap( VSBSliderMidBg ));
                // bottom
                p.fillRect(bgR.x() + 1, bgR.bottom() - 10, 13,10,qApp->palette().active().background() );
                p.drawPixmap( bgR.x() + 1, bgR.bottom() - 10, *getPixmap( VSBSliderBtmBg ) );


                if ( element == PE_ScrollBarSlider )
                {
                    if ( isHover )
                    {
                        QColor scrollCol = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOn ] : group.button();
                        QColor col = scrollCol.light( scrollBarStartNum_ );
                        QColor scrollBarBg = Qt::gray;

                        //top
                        QPixmap *topPix = verScrollBarTopDict_.find( col.rgb() );
                        if ( !topPix )
                        {
                            topPix = adjustHSV( *verScrollBarTopImg_, col, FALSE );
                            if ( topPix )
                                ptr->verScrollBarTopDict_.insert( col.rgb(), topPix );

                        }
                        if ( !topPix )
                        {
                            //qWarning( "topPix is NULL!" );
                            return ;
                        }
                        p.drawPixmap( rect.x() + 1, rect.y(), *topPix );

                        //btm
                        QPixmap *btmPix = verScrollBarBtmDict_.find( col.rgb() );
                        if ( !btmPix )
                        {
                            btmPix = adjustHSV( *verScrollBarBtmImg_, col, FALSE );
                            if ( btmPix )
                                ptr->verScrollBarBtmDict_.insert( col.rgb(), btmPix );
                        }
                        if ( !btmPix )
                        {
                            //qWarning( "btmPix is NULL!" );
                            return ;
                        }
                        p.drawPixmap( rect.x() + 1, rect.bottom() - 3, *btmPix );

                        //mid
                        QPixmap *midPix = verScrollBarMidDict_.find( col.rgb() );
                        if ( !midPix )
                        {
                            midPix = adjustHSV( *verScrollBarMidImg_, col, FALSE );
                            if ( midPix )
                                ptr->verScrollBarMidDict_.insert( col.rgb(), midPix );
                        }
                        if ( !midPix )
                        {
                            //qWarning( "midPix is NULL!" );
                            return ;
                        }

                        p.setClipRect(rect.x() + 1, rect.y() + 3, 13, rect.height() - 6, QPainter::CoordPainter);
                        p.drawTiledPixmap( rect.x() + 1, rect.y() + 3 - scrollBarMovementmShift_, 13, rect.height() - 6 + scrollBarMovementmShift_ , *midPix );
                    }
                    else
                    {
                        // top
                        p.drawPixmap( rect.x() + 1, rect.y(), *getPixmap( VSBSliderTop ) );
                        // mid
                        p.drawTiledPixmap( rect.x() + 1, rect.y() + 3, 13, rect.height() - 6 , *getPixmap( VSBSliderMid ) );
                        // btm
                        p.drawPixmap( rect.x() + 1, rect.bottom() - 3, *getPixmap( VSBSliderBtm ) );
                    }
                }

                p.setPen( QColor(140,140,140) );
                //p.setPen(Qt::red);
                p.drawLine( bgR.x(), bgR.y(), bgR.x(), bgR.bottom() );
                p.drawLine( bgR.right(), bgR.y(), bgR.right(), bgR.bottom() );

                p.end();
            }
            painter->drawPixmap( rect.x(), rect.y(), sbBuffer_, rect.x(), rect.y(), rect.width(), rect.height() );
            break;
        }

    case PE_ScrollBarAddLine:
        {
            QColor c = qApp->palette().active().background();

            painter->drawPixmap( x, y, horiz ? *getPixmap( scrollbuttonH ) : *getPixmap( scrollbuttonV ), 0, 0, w, h );

            painter->setPen( QColor(140,140,140) );
            if(horiz)
            {
                // top
                painter->drawLine(x, y, x2, y);
                // bottom
                painter->drawLine(x, y2, x2, y2);
                // right
                painter->drawLine(x2, y, x2, y2);

            }
            else
            {
                // left
                painter->drawLine(x, y, x, y2);
                // right
                painter->drawLine(x2, y, x2, y2);
                // bottom
                painter->drawLine(x, y2, x2, y2);
            }

            PrimitiveElement arrow = ( ( horiz ) ?
                                       ( ( element == PE_ScrollBarAddLine ) ?
                                         PE_ArrowRight : PE_ArrowLeft ) :
                                               ( ( element == PE_ScrollBarAddLine ) ?
                                                 PE_ArrowDown : PE_ArrowUp ) );
            if ( down )
    {
                // shift arrow
                switch ( arrow )
                {
                case PE_ArrowRight:
                        x++;
                    break;
                case PE_ArrowLeft:
                    x--;
                    break;
                case PE_ArrowDown:
                    y++;
                    break;
                case PE_ArrowUp:
                    y--;
                    break;
                default:
                    break;
                }
            }

            drawPrimitive( arrow, painter, QRect( x, y, h, w ), group, flags );
            break;
        }
    case PE_ScrollBarSubLine:
        {
            QColor c = qApp->palette().active().background();
            bool top = flags & Style_Horizontal ? rect.x() == 0 : rect.y() == 0;

            painter->drawPixmap( x, y, horiz ? *getPixmap( scrollbuttonH ) : *getPixmap( scrollbuttonV ), 0, 0, w, h );

            painter->setPen( QColor(140,140,140) );
            if(horiz)
            {
                // top
                painter->drawLine(x, y, x2, y);
                // bottom
                painter->drawLine(x, y2, x2, y2);

                if(top)
                {
                    // left
                    painter->drawLine(x, y, x, y2);
                }
                else
                {
                    // right
                    painter->drawLine(x2 - 1, y + 3 , x2 - 1, y2 - 3);
                    painter->setPen(Qt::white);
                    painter->drawLine(x2, y + 3, x2, y2 - 3);
                }
            }
            else
            {
                // left
                painter->drawLine(x, y, x, y2);
                // right
                painter->drawLine(x2, y, x2, y2);

                if(top)
                {
                    // top
                    painter->drawLine(x, y, x2, y);
                }
                else
                {
                    // bottom
                    painter->drawLine(x + 3, y2 - 1, x2 - 3, y2 - 1);
                    painter->setPen(Qt::white);
                    painter->drawLine(x + 3, y2, x2 - 3, y2);
                }
            }

            PrimitiveElement arrow = ( ( horiz ) ?
                                       ( ( element == PE_ScrollBarAddLine ) ?
                                         PE_ArrowRight : PE_ArrowLeft ) :
                                               ( ( element == PE_ScrollBarAddLine ) ?
                                                 PE_ArrowDown : PE_ArrowUp ) );
            if ( down )
    {
                // shift arrow
                switch ( arrow )
                {
                case PE_ArrowRight:
                        x++;
                    break;
                case PE_ArrowLeft:
                    x--;
                    break;
                case PE_ArrowDown:
                    y++;
                    break;
                case PE_ArrowUp:
                    y--;
                    break;
                default:
                    break;
                }
            }

            drawPrimitive( arrow, painter, QRect( x, y, h, w ), group, flags );
            break;
        }

        // chack_ box
    case PE_Indicator:
        {
            if ( !( off ) )
                painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( CBDownHover ) : *getPixmap( CBDown ) );
            else
                painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( CBHover ) : *getPixmap( CB ) );
            break;
        }


    case PE_IndicatorMask:
        {
            painter->fillRect( rect, Qt::color1 );
            break;
        }

        // radio button
    case PE_ExclusiveIndicator:

        {
            if ( depress )
                painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( RadioOnHover ) : *getPixmap( RadioOn ) );
            else
                painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( RadioOffHover ) : *getPixmap( RadioOff ) );
            break;

        }

    case PE_ExclusiveIndicatorMask:
        {
            painter->setPen( Qt::color1 );
            painter->drawPixmap( rect.x(), rect.y(), *getPixmap( HTMLRadioOff ) ->mask() );
            //painter->fillRect( rect, Qt::color1 );

            break;
        }

    case PE_DockWindowResizeHandle:
        {
            drawClearBevel( painter, x, y, w, h, group.button() );
            break;
        }

        // FIXME
    case PE_Splitter:
        {
            painter->setPen( Qt::gray );
            //painter->drawLine( x, y + 25, x, y + h - 25 );
            painter->drawLine( x + w - 1, y, x + w - 1, y + h );
            break;
        }

    case PE_PanelTabWidget:
        {
            painter->setPen( group.background().dark( 140 ) );
            painter->drawRect( rect );
            painter->setPen( group.background() );
            painter->drawLine( rect.right() - 1, rect.y() + 1, rect.right() - 1, rect.bottom() - 1 );
            painter->drawLine( rect.x() + 1, rect.bottom() - 1, rect.right() - 1, rect.bottom() - 1 );
            painter->setPen( group.background().light( 130 ) );
            painter->drawLine( rect.x() + 1, rect.y() + 1, rect.right() - 1, rect.y() + 1 );
            painter->drawLine( rect.x() + 1, rect.y() + 1, rect.x() + 1, rect.bottom() - 1 );
            break;
        }
    case PE_Panel:
        {
            bool sunken = flags & Style_Sunken;
            int lw = option.isDefault() ? pixelMetric( PM_DefaultFrameWidth ) : option.lineWidth();
            QPen oldPen( painter->pen() );
            if ( lw == 1 )
            {
                QColor light( group.background().light( 120 ) );
                QColor dark( group.background().dark( 140 ) );
                QColor mid( group.background().dark( 120 ) );
                painter->setPen( mid );
                painter->drawPoint( rect.x(), rect.bottom() );
                painter->drawPoint( rect.right(), rect.y() );

                painter->setPen( sunken ? dark : light );
                painter->drawLine( rect.x(), rect.y(), rect.right() - 1, rect.y() );
                painter->drawLine( rect.x(), rect.y() + 1, rect.x(), rect.bottom() - 1 );
                painter->setPen( sunken ? light : dark );
                painter->drawLine( rect.x() + 1, rect.bottom(), rect.right(), rect.bottom() );
                painter->drawLine( rect.right(), rect.y() + 1, rect.right(), rect.bottom() - 1 );
            }
            else if ( lw == 2 )
            {
                QColor light1, light2, light3, dark1, dark2, dark3;
                QColor mid( group.background().dark( 110 ) );
                if ( !sunken )
                {
                    light1 = group.background().light( 101 );
                    light2 = group.background().light( 120 );
                    light3 = group.background().light( 110 );
                    dark1 = group.background().dark( 115 );
                    dark2 = group.background().dark( 130 );
                    dark3 = group.background().dark( 110 );
                }
                else
                {
                    light1 = group.background().dark( 115 );
                    light2 = group.background().dark( 130 );
                    light3 = group.background().dark( 110 );
                    dark1 = group.background().light( 101 );
                    dark2 = group.background().light( 120 );
                    dark3 = group.background().light( 110 );
                }
                painter->setPen( light1 );
                painter->drawPoint( rect.x(), rect.y() );
                painter->setPen( dark1 );
                painter->drawPoint( rect.right(), rect.bottom() );
                painter->setPen( mid );
                painter->drawPoint( rect.x(), rect.bottom() );
                painter->drawPoint( rect.right(), rect.y() );

                painter->setPen( light2 );
                painter->drawLine( rect.x() + 1, rect.y(), rect.right() - 1, rect.y() );
                painter->drawLine( rect.x(), rect.y() + 1, rect.x(), rect.bottom() - 1 );

                painter->setPen( light3 );
                painter->drawLine( rect.x() + 1, rect.y() + 1, rect.right() - 1, rect.y() + 1 );
                painter->drawLine( rect.x() + 1, rect.y() + 1, rect.x() + 1, rect.bottom() - 1 );

                painter->setPen( dark2 );
                painter->drawLine( rect.x() + 1, rect.bottom(), rect.right() - 1, rect.bottom() );
                painter->drawLine( rect.right(), rect.y() + 1, rect.right(), rect.bottom() - 1 );

                painter->setPen( dark3 );
                painter->drawLine( rect.x() + 1, rect.bottom() - 1, rect.right() - 1, rect.bottom() - 1 );
                painter->drawLine( rect.right() - 1, rect.y() + 1, rect.right() - 1, rect.bottom() - 1 );
            }
            else
                KStyle::drawPrimitive( element, painter, rect, group, flags, option );
            painter->setPen( oldPen );
            break;
        }

    case PE_PanelLineEdit:
        {
            drawEditFrame( painter, rect, group );
            break;
        }

        //     case PE_TabBarBase:
        //         {
        //             painter->drawTiledPixmap(rect, *getPixmap(tabBase));
        //
        //             break;
        //         }

    case PE_TabBarBase:
        {
            painter->setPen( group.button().dark( 158 ) );
            painter->drawLine( rect.x(), rect.y(), rect.right() - 1, rect.y() );
            painter->drawLine( rect.x(), rect.y(), rect.x(), rect.bottom() );
            painter->drawLine( rect.x(), rect.bottom(), rect.right(), rect.bottom() );
            painter->drawLine( rect.right(), rect.y() + 1, rect.right(), rect.bottom() );
            painter->setPen( group.button().dark( 110 ) );
            painter->drawLine( rect.x() + 1, rect.y() + 1, rect.right() - 1, rect.y() + 1 );
            painter->drawLine( rect.x() + 1, rect.y() + 3, rect.right() - 1, rect.y() + 3 );
            painter->setPen( group.button().light( 110 ) );
            painter->drawLine( rect.x() + 1, rect.y() + 2, rect.right() - 1, rect.y() + 2 );
            break;


        }

    case PE_PanelPopup:
        {
            int x, y, w , h;
            rect.rect( &x, &y, &w, &h );

            QColor c ( 84, 84, 84 );
            painter->setPen( c.light( 100 ) );
            painter->drawRect( x, y, w, h );

            //painter->setPen( c.dark( 140 ) );
            //painter->drawRect( x + 1, y + 1, w - 2, h - 2 );
            //painter->fillRect(x,y,w,h,Qt::red);
            break;
        }
        //         case PE_WindowFrame:
        //         //drawMetal4kdePanel( painter, x, y, w, h, group, false );
        //         painter->fillRect(x,y,w,h,Qt::green);
        //         break;

        //         case PE_GroupBoxFrame:
        //         case PE_PanelGroupBox:
        //         painter->setPen( group.dark() );
        //         //painter->setPen( Qt::red );
        //         painter->drawRect( rect );
        //         break;


        //         case PE_Separator:
        //         painter->setPen( group.dark() );
        //         //painter->setPen( Qt::red );
        //         if ( w < h )
        //             painter->drawLine( w / 2, y, w / 2, y2 );
        //         else
        //             painter->drawLine( x, h / 2, x2, h / 2 );
        //         break;

    case PE_PanelDockWindow:
    case PE_PanelMenuBar:
        {
            //painter->fillRect(x,y,w,h,Qt::red );
            break;
        }

    case PE_DockWindowSeparator:
        {
            break;
        }


    case PE_CheckMark:
        painter->setPen( group.text() );
        painter->drawPixmap( x + w / 2 - 4, y + h / 2 - 4, bcheck );
        break;

    case PE_SpinWidgetPlus:
    case PE_SpinWidgetMinus:
        if ( enabled )
            painter->setPen( ( flags & Style_Sunken )
                             ? group.midlight() : group.dark() );
        else
            painter->setPen( group.mid() );
        painter->drawPixmap( x + w / 2 - 3, y + h / 2 - 3,
                             ( element == PE_SpinWidgetPlus ) ? bplus : bminus );
        break;

    case PE_SpinWidgetUp:
    case PE_ArrowUp:
        if ( flags & Style_Enabled )
            painter->setPen( ( flags & Style_Sunken )
                             ? group.midlight() : Qt::black );
        else
            painter->setPen( Qt::black );
        painter->drawPixmap( x + w / 2 - 3, y + h / 2 - 3, uarrow );
        break;

    case PE_SpinWidgetDown:
    case PE_ArrowDown:
        if ( enabled )
            painter->setPen( ( flags & Style_Sunken )
                             ? group.midlight() : Qt::black );
        else
            painter->setPen( Qt::black );
        painter->drawPixmap( x + w / 2 - 3, y + h / 2 - 3, darrow );
        break;

    case PE_ArrowLeft:
        if ( enabled )
            painter->setPen( ( flags & Style_Sunken )
                             ? group.midlight() : Qt::black );
        else
            painter->setPen( Qt::black );
        painter->drawPixmap( x + w / 2 - 3, y + h / 2 - 3, larrow );
        break;

    case PE_ArrowRight:
        if ( enabled )
            painter->setPen( ( flags & Style_Sunken )
                             ? group.midlight() : Qt::black );
        else
            painter->setPen( Qt::black );
        painter->drawPixmap( x + w / 2 - 3, y + h / 2 - 3, rarrow );
        break;

    default:
        KStyle::drawPrimitive( element, painter, rect, group, flags, option );
    }
}

//////////////////////////////////////////////////////////////////////////////
// drawKStylePrimitive()
// ---------------------
// Draw the element

void Metal4kdeStyle::drawKStylePrimitive( KStylePrimitive element,
        QPainter *painter,
        const QWidget *widget,
        const QRect &rect,
        const QColorGroup &group,
        SFlags flags,
        const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawKStylePrimitive() called" );
#endif


    bool horiz = flags & Style_Horizontal;
    int x, y, w, h, x2, y2, cx, cy;

    rect.rect( &x, &y, &w, &h );
    x2 = rect.right();
    y2 = rect.bottom();
    cx = x + w / 2;
    cy = y + h / 2;


    switch ( element )
    {
    case KPE_ToolBarHandle:
        drawClearBevel( painter, rect.x(), rect.y(), rect.width(), rect.height(), group.background() );
        break;

        //case KPE_DockWindowHandle:
    case KPE_GeneralHandle:
        if ( horiz )
        { // horizontal
            painter->fillRect( rect, group.brush( QColorGroup::Background ) );
            //painter->fillRect( rect, QBrush( Qt::red ) );

            painter->setPen( group.mid() );
            painter->drawLine( cx - 2, y, cx - 2, y2 - 1 );
            painter->drawLine( cx + 1, y, cx + 1, y2 - 1 );

            painter->setPen( group.midlight() );
            painter->drawLine( cx - 1, y + 1, cx - 1, y2 );
            painter->drawLine( cx + 2, y + 1, cx + 2, y2 );
        }
        else
        { // vertical
            painter->fillRect( rect, group.brush( QColorGroup::Background ) );

            painter->setPen( group.mid() );
            painter->drawLine( x, cy - 2, x2 - 1, cy - 2 );
            painter->drawLine( x, cy + 1, x2 - 1, cy + 1 );

            painter->setPen( group.midlight() );
            painter->drawLine( x + 1, cy - 1, x2, cy - 1 );
            painter->drawLine( x + 1, cy + 2, x2, cy + 2 );
        }
        break;

    case KPE_ListViewExpander:
        painter->setPen( group.mid() );
        if ( flags & Style_On )
        {
            painter->drawPixmap( x + w / 2 - 4, y + h / 2 - 4, rexpand );
        }
        else
        {
            painter->drawPixmap( x + w / 2 - 4, y + h / 2 - 4, dexpand );
        }
        break;

    case KPE_ListViewBranch:
        painter->setPen( group.mid() );
        //         painter->setPen( Qt::red );
        if ( flags & Style_Horizontal )
        {
            painter->drawLine( x, cy, x2, cy );
        }
        else
        {
            painter->drawLine( cx, y, cx, y2 );
        }
        break;

    case KPE_SliderGroove:
        {
            QColor c = widget->hasFocus() ? group.background().dark( 120 ) :
                       group.background();
            int x, y, w, h;
            rect.rect( &x, &y, &w, &h );
            if ( ( ( const QSlider * ) widget ) ->orientation() == Qt::Horizontal )
            {
                int x2 = x + w - 1;
                y = y + ( h - 5 ) / 2;
                painter->setPen( c.dark( 130 ) );
                painter->drawLine( x + 1, y, x2 - 1, y );
                painter->setPen( c.dark( 150 ) );
                painter->drawLine( x, y + 1, x2, y + 1 );
                painter->setPen( c.dark( 125 ) );
                painter->drawLine( x, y + 2, x2, y + 2 );
                painter->setPen( c.dark( 130 ) );
                painter->drawLine( x, y + 3, x2, y + 3 );
                painter->setPen( c.dark( 120 ) );
                painter->drawLine( x, y + 4, x2, y + 4 );
                painter->setPen( c.light( 110 ) );
                painter->drawLine( x + 1, y + 5, x2 - 1, y + 5 );
            }
            else
            {
                int y2 = y + h - 1;
                x = x + ( w - 5 ) / 2;
                painter->setPen( c.dark( 130 ) );
                painter->drawLine( x, y + 1, x, y2 - 1 );
                painter->setPen( c.dark( 150 ) );
                painter->drawLine( x + 1, y, x + 1, y2 );
                painter->setPen( c.dark( 125 ) );
                painter->drawLine( x + 2, y, x + 2, y2 );
                painter->setPen( c.dark( 130 ) );
                painter->drawLine( x + 3, y, x + 3, y2 );
                painter->setPen( c.dark( 120 ) );
                painter->drawLine( x + 4, y, x + 4, y2 );
                painter->setPen( c.light( 110 ) );
                painter->drawLine( x + 5, y + 1, x + 5, y2 - 1 );
            }
            break;
        }

    case KPE_SliderHandle:
        {
            bool mouseover = ( widget == hover_ );

            //                   if ( ( ( const QSlider * ) widget ) ->orientation() == Qt::Horizontal )
            painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( HSliderOver ) : *getPixmap( HSlider  ) );
            //                   else
            //                         painter->drawPixmap( rect.x(), rect.y(), mouseover ? *getPixmap( VSliderOver, group ) : *getPixmap( VSlider, group ) );
            break;
        }

    default:
        KStyle::drawKStylePrimitive( element, painter, widget, rect,
                                     group, flags, option );
    }
}

//////////////////////////////////////////////////////////////////////////////
// drawControl()
// -------------
// Draw the control

void Metal4kdeStyle::drawControl( ControlElement element,
                                  QPainter *painter,
                                  const QWidget *widget,
                                  const QRect &rect,
                                  const QColorGroup &group,
                                  SFlags flags,
                                  const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawControl()" );
#endif

    bool active, enabled /*, depress*/;
    int x, y, w, h, x2, y2, dx;
    QMenuItem *mi;
    QIconSet::Mode mode;
    QIconSet::State state;
    QPixmap pixmap;

    rect.rect( &x, &y, &w, &h );
    x2 = rect.right();
    y2 = rect.bottom();

    switch ( element )
    {
    case CE_PushButton:
        {
            const QPushButton * btn = ( const QPushButton* ) widget;
            const_cast<Metal4kdeStyle*>( this ) ->isHTMLButton_ = isHTMLWidget( btn );
            const_cast<Metal4kdeStyle*>( this ) ->btnOffset_ = btn->backgroundOffset();
            QColor col = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOff ] : group.background();
            QColor hoverCol = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOn ] : group.button();
            bool down = flags & Style_Down;
            bool on = flags & Style_On;
            bool depress = ( down || on );
            bool mouseover;

            if ( optionsHandler_->enableAnimate_ )
            {
                char widgetId[ 20 ] = {0};
                sprintf( widgetId, "%ul", widget->winId() );
                animationWidget *animWidget;
                animWidget = animationWidgetDict_.find( widgetId );
                if ( animWidget )
                {
                    if ( animWidget->hover_ == true )
                        flags |= Style_MouseOver;
                }

                mouseover = ( flags & Style_MouseOver );

                drawMetalButton( painter, x, y, w, h, group, mouseover ? hoverCol.light( animWidget->animProgress_ ) : col, isHTMLButton_, depress, btnOffset_.x(), btnOffset_.y() );
            }
            else
            {
                if ( widget == hover_ )
                    flags |= Style_MouseOver;

                if ( btn->isDefault() )
                    drawPrimitive( PE_ButtonDefault, painter, rect, group, flags );
                else
                    drawPrimitive( PE_ButtonCommand, painter, rect, group, flags );
            }


            if ( flags & Style_HasFocus )
            { // draw focus
                drawPrimitive( PE_FocusRect, painter,
                               subRect( SR_PushButtonFocusRect, widget ),
                               group, flags );
            }
            break;
        }

    case CE_PushButtonLabel:
        {
            const QPushButton* button = dynamic_cast<const QPushButton*>( widget );
            if ( !button )
            {
                KStyle::drawControl( element, painter, widget, rect, group,
                                     flags, option );
                return ;
            }
            active = button->isOn() || button->isDown();
            QColor dark = Qt::black, light = Qt::white;

            if ( active )
            { // shift contents
                x++;
                y++;
                flags |= Style_Sunken;
            }

            if ( button->isMenuButton() )
            { // draw the indicator
                dx = pixelMetric( PM_MenuButtonIndicator, widget );
                w -= dx;
                drawPrimitive( PE_ArrowDown, painter,
                               QRect( x + w - 2, y + 2, dx, h - 4 ),
                               group, flags, option );
            }

            if ( button->iconSet() && !button->iconSet() ->isNull() )
            { // draw icon
                if ( button->isEnabled() )
                {
                    if ( button->hasFocus() )
                    {
                        mode = QIconSet::Active;
                    }
                    else
                    {
                        mode = QIconSet::Normal;
                    }
                }
                else
                {
                    mode = QIconSet::Disabled;
                }

                if ( button->isToggleButton() && button->isOn() )
                {
                    state = QIconSet::On;
                }
                else
                {
                    state = QIconSet::Off;
                }

                pixmap = button->iconSet() ->pixmap( QIconSet::Small, mode, state );
                if ( button->text().isEmpty() && !button->pixmap() )
                {
                    painter->drawPixmap( x + w / 2 - pixmap.width() / 2,
                                         y + h / 2 - pixmap.height() / 2, pixmap );
                }
                else
                {
                    painter->drawPixmap( x + 4, y + h / 2 - pixmap.height() / 2, pixmap );
                }
                x += pixmap.width() + 4;
                w -= pixmap.width() + 4;
            }

            if ( active || button->isDefault() )
            { // default button
                for ( int n = 0; n < 2; n++ )
                {
                    drawItem( painter, QRect( x + n, y, w, h ),
                              AlignCenter | ShowPrefix,
                              button->colorGroup(),
                              button->isEnabled(),
                              button->pixmap(),
                              button->text(), -1,
                              ( button->isEnabled() ) ?
                              ( button->isDefault() ? &dark : &light ) :
                                      &button->colorGroup().mid() );
                }
            }
            else if ( hover_ == widget )
    {
                // hover button
                drawItem( painter, QRect( x, y, w, h ),
                          AlignCenter | ShowPrefix,
                          button->colorGroup(),
                          button->isEnabled(),
                          button->pixmap(),
                          button->text(), -1,
                          ( button->isEnabled() ) ?
                          &light :
                          &button->colorGroup().mid() );
            }
            else
            {
                // normal button
                drawItem( painter, QRect( x, y, w, h ),
                          AlignCenter | ShowPrefix,
                          button->colorGroup(),
                          button->isEnabled(),
                          button->pixmap(),
                          button->text(), -1,
                          ( button->isEnabled() ) ?
                          &button->colorGroup().buttonText() :
                          &button->colorGroup().mid() );
            }
            break;
        }

    case CE_CheckBoxLabel:
    case CE_RadioButtonLabel:
        {
            const QButton *b = dynamic_cast<const QButton*>( widget );
            if ( !b )
                return ;
            //painter->drawTiledPixmap(rect, *brushedMetalLightningPix_);
            //painter->fillRect(rect, Qt::red);

            int alignment = reverse_ ? AlignRight : AlignLeft;
            drawItem( painter, rect, alignment | AlignVCenter | ShowPrefix,
                      group, flags & Style_Enabled, b->pixmap(), b->text() );

            // only draw focus if content (forms on html won't)
            if ( ( flags & Style_HasFocus ) && ( ( b->text() ) || b->pixmap() ) )
            {
                drawPrimitive( PE_FocusRect, painter,
                               visualRect( subRect( SR_RadioButtonFocusRect,
                                                    widget ), widget ),
                               group, flags );
            }
            break;
        }
    case CE_MenuBarItem:
        {
            QMenuItem *mi = option.menuItem();
            bool active = flags & Style_Active;
            bool focused = flags & Style_HasFocus;

            if ( active && focused )
            {
                drawClearBevel( painter, rect.x(), rect.y(), rect.width(), rect.height(),
                                group.button() );
            }
            //             else
            //                 painter->drawTiledPixmap( x, y, w, h, *brushedMetalPix_ );

            drawItem( painter, rect, AlignCenter | AlignVCenter | ShowPrefix | DontClip | SingleLine, group, flags & Style_Enabled, mi->pixmap(), mi->text() );

            break;
        }

    case CE_PopupMenuItem:
        {
            const QPopupMenu *popup = dynamic_cast<const QPopupMenu*>( widget );
            if ( !popup )
            {
                KStyle::drawControl( element, painter, widget, rect, group,
                                     flags, option );
                return ;
            }

            mi = option.menuItem();
            if ( !mi )
            {
                //painter->drawTiledPixmap( x, y, w, h, *brushedMetalPix_ );
                break;
            }

            int tabwidth = option.tabWidth();
            int checkwidth = option.maxIconWidth();
            bool checkable = popup->isCheckable();
            bool etchtext = styleHint( SH_EtchDisabledText );
            // bool etchtext = styleHint( SH_EtchDisabledText );
            active = flags & Style_Active;
            enabled = mi->isEnabled();
            QRect vrect;

            if ( checkable )
                checkwidth = QMAX( checkwidth, 20 );

            // draw background
            if ( active && enabled )
            {
                drawClearBevel( painter, x, y, w, h, group.button(), TRUE );
            }
            else if ( widget->erasePixmap() && !widget->erasePixmap() ->isNull() )
            {
                painter->drawPixmap( x, y, *widget->erasePixmap(), x, y, w, h );
            }
            else
            {
                QPixmap pix( w, h );
                QPainter p;

                p.begin( &pix );
                p.drawPixmap( 0, 0, *brushedMetalPix_ );
                p.drawPixmap( 0, 0, *menuLeftPix_ );
                p.drawPixmap( w - 50, 0, *menuRightPix_ );
                p.end();

                //painter->drawPixmap( x, y, pix );
            }

            // draw separator
            if ( mi->isSeparator() )
            {
                painter->setPen( group.dark() );
                painter->drawLine( x + checkwidth + 1, y + 1, x2 - checkwidth - 1, y + 1 );
                painter->setPen( group.mid() );
                painter->drawLine( x + checkwidth, y, x2 - checkwidth - 1, y );
                painter->drawPoint( x + checkwidth, y + 1 );
                painter->setPen( group.midlight() );
                painter->drawLine( x + checkwidth + 1, y2, x2 - checkwidth, y2 );
                painter->drawPoint( x2 - checkwidth, y2 - 1 );
                break;
            }

            // draw icon
            if ( mi->iconSet() && !mi->isChecked() )
            {
                if ( active )
                    mode = enabled ? QIconSet::Active : QIconSet::Disabled;
                else
                    mode = enabled ? QIconSet::Normal : QIconSet::Disabled;

                pixmap = mi->iconSet() ->pixmap( QIconSet::Small, mode );
                QRect pmrect( 0, 0, pixmap.width(), pixmap.height() );
                vrect = visualRect( QRect( x, y, checkwidth, h ), rect );
                pmrect.moveCenter( vrect.center() );
                painter->drawPixmap( pmrect.topLeft().x() + 10, pmrect.topLeft().y(), pixmap );
            }

            // draw check
            if ( mi->isChecked() )
            {
                int cx = reverse_ ? x + w - checkwidth - 10 : x + 10;
                drawPrimitive( PE_CheckMark, painter,
                               QRect( cx + ITEMFRAME, y + ITEMFRAME,
                                      checkwidth - ITEMFRAME * 2, h - ITEMFRAME * 2 ),
                               group, Style_Default |
                               ( active ? Style_Enabled : Style_On ) );
            }

            // draw text
            int xm = ITEMFRAME + checkwidth + 10 + ITEMHMARGIN;
            int xp = reverse_ ?
                     x + tabwidth + RIGHTBORDER + ITEMHMARGIN + ITEMFRAME - 1 :
                     x + xm;
            int offset = reverse_ ? -1 : 1;
            int tw = w - xm - tabwidth - ARROWMARGIN - ITEMHMARGIN * 3
                     - ITEMFRAME + 1;

            //painter->setPen( enabled ? ( active ? group.highlightedText() : group.buttonText() ) : group.mid() );
            painter->setPen( enabled ? group.buttonText() : group.mid() );

            if ( mi->custom() )
            { // draws own label
                painter->save();
                if ( etchtext && !enabled && !active )
                {
                    painter->setPen( group.light() );
                    mi->custom() ->paint( painter, group, active, enabled,
                                          xp + offset, y + ITEMVMARGIN + 1,
                                          tw, h - 2 * ITEMVMARGIN );
                    painter->setPen( group.mid() );
                }
                mi->custom() ->paint( painter, group, active, enabled,
                                      xp, y + ITEMVMARGIN, tw, h - 2 * ITEMVMARGIN );
                painter->restore();
            }
            else
            { // draw label
                QString text = mi->text();

                if ( !text.isNull() )
                {
                    int t = text.find( '\t' );
                    int tflags = AlignVCenter | DontClip |
                                 ShowPrefix | SingleLine |
                                 ( reverse_ ? AlignRight : AlignLeft );

                    if ( t >= 0 )
                    {
                        int tabx = reverse_ ?
                                   x + RIGHTBORDER + ITEMHMARGIN + ITEMFRAME :
                                   x + w - tabwidth - RIGHTBORDER - ITEMHMARGIN
                                   - ITEMFRAME;

                        // draw right label (accerator)
                        if ( etchtext && !enabled )
                        { // etched
                            painter->setPen( group.light() );
                            painter->drawText( tabx + offset, y + ITEMVMARGIN + 1,
                                               tabwidth, h - 2 * ITEMVMARGIN,
                                               tflags, text.mid( t + 1 ) );
                            painter->setPen( group.mid() );
                        }
                        painter->drawText( tabx, y + ITEMVMARGIN,
                                           tabwidth, h - 2 * ITEMVMARGIN,
                                           tflags, text.mid( t + 1 ) );
                        text = text.left( t );
                    }

                    // draw left label
                    if ( etchtext && !enabled )
                    { // etched
                        painter->setPen( group.light() );
                        painter->drawText( xp + offset, y + ITEMVMARGIN + 1,
                                           tw, h - 2 * ITEMVMARGIN,
                                           tflags, text, t );
                        painter->setPen( group.mid() );
                    }
                    painter->drawText( xp, y + ITEMVMARGIN,
                                       tw, h - 2 * ITEMVMARGIN,
                                       tflags, text, t );
                }
                else if ( mi->pixmap() )
                { // pixmap as label
                    pixmap = *mi->pixmap();
                    if ( pixmap.depth() == 1 )
                        painter->setBackgroundMode( OpaqueMode );

                    dx = ( ( w - pixmap.width() ) / 2 ) + ( ( w - pixmap.width() ) % 2 );
                    painter->drawPixmap( x + dx, y + ITEMFRAME, pixmap );

                    if ( pixmap.depth() == 1 )
                        painter->setBackgroundMode( TransparentMode );
                }
            }

            if ( mi->popup() )
            { // draw submenu arrow
                PrimitiveElement arrow = reverse_ ? PE_ArrowLeft : PE_ArrowRight;
                int dim = ( h - 2 * ITEMFRAME ) / 2;
                vrect = visualRect( QRect( x + w - ARROWMARGIN - ITEMFRAME - dim,
                                           y + h / 2 - dim / 2, dim, dim ), rect );
                drawPrimitive( arrow, painter, vrect, group,
                               enabled ? Style_Enabled : Style_Default );
            }
            break;
        }

    case CE_TabBarTab:
        {
            if ( !widget || !widget->parentWidget() )
                break;

            const QTabBar *tabBar = ( const QTabBar * ) widget;
            QTab *tab = option.tab();
            //qWarning("count - %d",tabBar->count());
            // 	    //qWarning("id - %d",tabBar->currentTab());
            //qWarning("%d",(int)tab->identifier());
            bool selected = flags & Style_Selected;
            bool mouseOver = flags & Style_MouseOver;
            QPixmap *pix, *pixL, *pixR;
            int outWidth, inWidth;

            bool above = tabBar->shape() == QTabBar::RoundedAbove || tabBar->shape() == QTabBar::TriangularAbove;
            if ( !above )
            {
                outWidth =10, inWidth = 30;
                if ( selected )
                {
                    pixR = mouseOver ? getPixmap( belowTabRightOver ) : getPixmap( belowTabRightDown );
                    pixL = mouseOver ? getPixmap( belowTabLeftOver ) : getPixmap( belowTabLeftDown );
                }
                else
                {
                    pixR = mouseOver ? getPixmap( belowTabRightOver ) : getPixmap( belowTabRight );
                    pixL = mouseOver ? getPixmap( belowTabLeftOver ) : getPixmap( belowTabLeft );
                }
            }
            else
            {
                outWidth =30, inWidth = 10;
                if ( selected )
                {
                    pixR = mouseOver ? getPixmap( TabRightOver ) : getPixmap( TabRightDown );
                    pixL = mouseOver ? getPixmap( TabLeftOver ) : getPixmap( TabLeftDown );
                }
                else
                {
                    pixR = mouseOver ? getPixmap( TabRightOver ) : getPixmap( TabRight );
                    pixL = mouseOver ? getPixmap( TabLeftOver ) : getPixmap( TabLeft );
                }
            }
            QPixmap tilePix;

            if( tab == tabBar->tabAt(0) )
            {
                painter->drawPixmap( rect.x(), above ? rect.y() : rect.y() - 8, *pixL, 0, 0, outWidth, pixL->height() );
                // mid
                tilePix.resize( 1, pixL->height() );
                bitBlt( &tilePix, 0, 0, pixL, outWidth, 0, 1, pixL->height() );
                painter->drawTiledPixmap( rect.x() + outWidth, above ? rect.y() : rect.y() - 8, rect.width() - (outWidth + inWidth), pixL->height(), tilePix );
                //                 tilePix.resize( pixL->width() - (outWidth + inWidth), pixL->height() );
                //                 bitBlt( &tilePix, 0, 0, pixL, outWidth, 0, pixL->width() - (outWidth + inWidth), pixL->height() );
                //                 painter->drawTiledPixmap( rect.x() + outWidth, above ? rect.y() : rect.y() - 8, rect.width() - (outWidth + inWidth), pixL->height(), tilePix );
                // right
                painter->drawPixmap( rect.right() - inWidth, above ? rect.y() : rect.y() - 8, *pixL, 85 - inWidth, 0, inWidth , pixL->height() );
            }
            //else if( tab->identifier() == tabBar->count() -1 )
            else if( tab == tabBar->tabAt(tabBar->count() -1 ))
            {
                painter->drawPixmap( rect.x(), above ? rect.y() : rect.y() - 8, *pixR, 0, 0, inWidth, pixR->height() );
                // mid
                tilePix.resize( pixR->width() - (outWidth + inWidth), pixR->height() );
                bitBlt( &tilePix, 0, 0, pixR, inWidth, 0, pixR->width() - (outWidth + inWidth), pixR->height() );
                painter->drawTiledPixmap( rect.x() + inWidth, above ? rect.y() : rect.y() - 8, rect.width() - (outWidth + inWidth), pixR->height(), tilePix );
                // right
                painter->drawPixmap( rect.right() - outWidth, above ? rect.y() : rect.y() - 8, *pixR, 85 - outWidth, 0, outWidth , pixR->height() );
            }
            else
            {
                painter->drawPixmap( rect.x(), above ? rect.y() : rect.y() - 8, *pixR, 0, 0, inWidth, pixR->height() );
                // mid
                tilePix.resize( pixR->width() - (outWidth + inWidth), pixR->height() );
                bitBlt( &tilePix, 0, 0, pixR, inWidth, 0, pixR->width() - (outWidth + inWidth), pixR->height() );
                painter->drawTiledPixmap( rect.x() + inWidth, above ? rect.y() : rect.y() - 8, rect.width() - (inWidth + inWidth), pixL->height(), tilePix );
                // right
                painter->drawPixmap( rect.right() - inWidth, above ? rect.y() : rect.y() - 8, *pixL, 85 - inWidth, 0, inWidth , pixL->height() );
            }
            break;
        }

        //     case CE_TabBarTab:
        //         {
        //             if ( !widget || !widget->parentWidget() )
        //                 break;
        //
        //             const QTabBar *tabBar = ( const QTabBar * ) widget;
        //             bool selected = flags & Style_Selected;
        //             bool mouseOver = flags & Style_MouseOver;
        //             QPixmap *pix;
        //
        //             bool above = tabBar->shape() == QTabBar::RoundedAbove || tabBar->shape() == QTabBar::TriangularAbove;
        //             if ( !above )
        //             {
        //                 if ( selected )
        //                     pix = mouseOver ? getPixmap( belowTabOver, group ) : getPixmap( belowTabDown, group );
        //                 else
        //                     pix = mouseOver ? getPixmap( belowTabOver, group ) : getPixmap( belowTab, group );
        //             }
        //             else
        //             {
        //                 if ( selected )
        //                     pix = mouseOver ? getPixmap( TabOver, group ) : getPixmap( TabDown, group );
        //                 else
        //                     pix = mouseOver ? getPixmap( TabOver, group ) : getPixmap( Tab, group );
        //             }
        //             QPixmap tilePix;
        //
        //             // left
        //             painter->drawPixmap( rect.x(), above ? rect.y() : rect.y() - 8, *pix, 0, 0, 12, pix->height() );
        //             // right
        //             painter->drawPixmap( rect.right() - 12, above ? rect.y() : rect.y() - 8, *pix, pix->width() - 12, 0, 12, pix->height() );
        //             // midddle
        //             tilePix.resize( pix->width() - 24, pix->height() );
        //             bitBlt( &tilePix, 0, 0, pix, 12, 0, pix->width() - 24, pix->height() );
        //             painter->drawTiledPixmap( rect.x() + 12, above ? rect.y() : rect.y() - 8, rect.width() - 24, pix->height(), tilePix );
        //             break;
        //         }
    case CE_ProgressBarGroove:
        {
            //             painter->setPen( group.background().dark( 150 ) );
            //             painter->drawRect( rect );
            //             painter->fillRect( rect.x() + 1, rect.y() + 1, rect.width() - 2, rect.height() - 2, group.base() );
            QPixmap * pix;
            pix = getPixmap( ProgressH );
            painter->drawTiledPixmap(x,y,w,h, *pix);
            painter->setPen( QColor(180,180,180) );
            painter->drawRect(x,y,w,h);
            painter->setPen( QColor(130,130,130) );
            painter->drawLine(x,y,x+w,y);
            painter->drawLine(x,y,x,y+h);
            //qWarning("h - %d",h);
            break;
        }

    case CE_ProgressBarContents:
        {
            const QProgressBar *progress = (const QProgressBar *)widget;
            QRect contentsR(subRect(SR_ProgressBarContents, widget));
            //qWarning("h - %d",contentsR.height());
            double val = progress->progress();
            bool reverse = QApplication::reverseLayout();
            val = val/progress->totalSteps();
            if(val > 0.0)
            {
                int w = QMIN(contentsR.width(), (int)(val * contentsR.width()));
                if(w > 1)
                {
                    int x = contentsR.x();
                    int y = contentsR.y();
                    int x2 = contentsR.x()+w-1;
                    int y2 = contentsR.bottom();
                    QRect progressRect;
                    if (reverse)
                        progressRect = QRect(contentsR.x()+(contentsR.width()-w), contentsR.y(), w, contentsR.height()+1);
                    else
                        progressRect = QRect(contentsR.x(), contentsR.y(), w, contentsR.height()+1);
                    //Clip to the old rectangle
                    painter->setClipRect(progressRect, QPainter::CoordPainter);
                    //Expand the paint region slightly to get the animation offset.
                    progressRect.setLeft(progressRect.x() - 46 + progAnimShift_);
                    //                 painter->setPen(group.button().dark(120));
                    //                 painter->drawLine(x, y, x2, y);
                    //                 painter->drawLine(x, y, x, y2);
                    //                 //if(optionHandler->useanimateProgressBar())                     p->drawLine(x+1, y2+1, x2-1, y2+1);
                    //                 painter->setPen(group.button().dark(110));
                    //                 painter->drawLine(x2, y, x2, y2);
                    //                 painter->drawLine(x, y2, x2, y2);
                    QPixmap * pix;
                    //pix = getPixmap( ProgressH, group );
                    //painter->drawTiledPixmap(x,y,w,h, *pix);
                    pix = getPixmap( ProgressL);
                    painter->drawPixmap( x, y, *pix, 0, 0, 5, 20 );
                    //pix = getPixmap( ProgressM, group );
                    //painter->drawTiledPixmap( x+5,y,w-10,20, *pix, 0, 0 );
                    pix = getPixmap( ProgressR );
                    painter->drawPixmap( x+w-5, y, *pix, 0, 0, 5, 20 );

                    painter->setClipRect(x+5,progressRect.y(),progressRect.width()-10,progressRect.height(), QPainter::CoordPainter);
                    pix = getPixmap( ProgressM );
                    painter->drawTiledPixmap(progressRect.x()+5,progressRect.y(),progressRect.width()-10,progressRect.height(), *pix);
                }
            }
            break;
        }



        //     case CE_ProgressBarContents:
        //         {
        // 	painter->fillRect(x,y,w,h,Qt::green);
        // //             const QProgressBar *progress = ( const QProgressBar * ) widget;
        //             QRect contentsR( subRect( SR_ProgressBarContents, widget ) );
        // 	    painter->fillRect(contentsR,Qt::blue);
        // //             //QRect contentsR( x,y,w,h );
        // //             double val = progress->progress();
        // //             bool reverse = QApplication::reverseLayout();
        // //             val = val / progress->totalSteps();
        // //             if ( val > 0.0 )
        // //             {
        // //                 int w = QMIN( contentsR.width(), ( int ) ( val * contentsR.width() ) );
        // //                 if ( w > 1 )
        // //                 {
        // //                     int x = contentsR.x();
        // //                     int y = contentsR.y();
        // //                     int x2 = contentsR.x() + w - 1;
        // //                     int y2 = contentsR.bottom();
        //                     QRect progressRect;
        // //                     if ( reverse )
        // //                         progressRect = QRect( contentsR.x() + ( contentsR.width() - w ), contentsR.y(), w, contentsR.height() + 1 );
        // //                     else
        //                         progressRect = QRect( contentsR.x(), contentsR.y(), w, contentsR.height() + 1 );
        // 			painter->fillRect(contentsR,Qt::gray);
        // //                     Clip to the old rectangle
        // //                     painter->setClipRect( progressRect, QPainter::CoordPainter );
        // //                     //Expand the paint region slightly to get the animation offset.
        // //                     //progressRect.setLeft( progressRect.x() - 20 + progAnimShift_ );
        // //                     painter->setPen( group.button().dark( 120 ) );
        // //                     painter->drawLine( x, y, x2, y );
        // //                     painter->drawLine( x, y, x, y2 );
        // //                     //if(optionHandler->useanimateProgressBar())                     painter->drawLine(x+1, y2+1, x2-1, y2+1);
        // //                     painter->setPen( group.button().dark( 110 ) );
        // //                     painter->drawLine( x2, y, x2, y2 );
        // //                     painter->drawLine( x, y2, x2, y2 );
        // //
        // //                     QPixmap * pix;
        // //                     pix = getPixmap( ProgressL, group );
        // //                     painter->drawPixmap( x, y, *pix, 0, 0, 5, 20 );
        // //                     pix = getPixmap( ProgressM, group );
        // //                     painter->drawTiledPixmap( x+5,y,w-10,20, *pix, 0, 0 );
        // //                     pix = getPixmap( ProgressR, group );
        // //                     painter->drawPixmap( x+w-5, y, *pix, 0, 0, 5, 20 );
        // //
        // //
        // //                 }
        // //             }
        //             break;
        //         }

    default:
        KStyle::drawControl( element, painter, widget, rect, group,
                             flags, option );
    }
}
//////////////////////////////////////////////////////////////////////////////
// drawControlMask()
// -----------------
// Draw a bitmask for the element

void Metal4kdeStyle::drawControlMask( ControlElement element,
                                      QPainter *painter,
                                      const QWidget *widget,
                                      const QRect &rect,
                                      const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawControlMask()" );
#endif

    switch ( element )
    {
        //                 case CE_PushButton:
        //                 painter->fillRect( rect, Qt::color1 );
        //                 painter->setPen( Qt::color0 );
        //                 break;

    default:
        KStyle::drawControlMask( element, painter, widget, rect, option );
    }
}

//////////////////////////////////////////////////////////////////////////////
// drawComplexControl()
// --------------------
// Draw a complex control

void Metal4kdeStyle::drawComplexControl( ComplexControl control,
        QPainter *painter,
        const QWidget *widget,
        const QRect &rect,
        const QColorGroup &group,
        SFlags flags,
        SCFlags controls,
        SCFlags active,
        const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawComplexControl()" );
#endif


    bool down = flags & Style_Down;
    bool on = flags & Style_On;
    bool raised = flags & Style_Raised;
    bool sunken = flags & Style_Sunken;
    QRect subrect;
    int x, y, w, h;
    rect.rect( &x, &y, &w, &h );

    switch ( control )
    {

    case CC_ComboBox:
        {

            const QComboBox * combo = ( const QComboBox* ) widget;
            const_cast<Metal4kdeStyle*>( this ) ->isHTMLButton_ = isHTMLWidget( combo );
            const_cast<Metal4kdeStyle*>( this ) ->btnOffset_ = combo->backgroundOffset();
            //qWarning("x - %d, y - %d", btnOffset_.x(), btnOffset_.y());
            QColor col = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOff ] : group.background();
            QColor hoverCol = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOn ] : group.button();
            bool mouseover = false;

            if ( optionsHandler_->enableAnimate_ )
            {
                char widgetId[ 20 ] = {0};
                sprintf( widgetId, "%ul", widget->winId() );
                animationWidget *animWidget;
                animWidget = animationWidgetDict_.find( widgetId );
                if ( animWidget )
                {
                    if ( animWidget->hover_ == true )
                        mouseover = true;
                }

                drawMetalCombo( combo, painter,mouseover, controls, rect, mouseover ? hoverCol.light( animWidget->animProgress_ ) : col, isHTMLButton_, group, x, y, flags, active );
            }
            else
            {
                if ( widget == hover_ )
                    mouseover = true;
                drawMetalCombo( combo, painter,mouseover, controls, rect, mouseover ? hoverCol : col, isHTMLButton_, group, x, y, flags, active );
            }

            break;
        }

    case CC_ScrollBar:
        {
            const_cast<Metal4kdeStyle*>( this ) ->currentScrollBar_ = ( QScrollBar * ) widget;
            KStyle::drawComplexControl( control, painter, widget, rect, group, flags, controls, active, option );
            break ;
        }

    case CC_ToolButton:
        {
            if ( down || on )
            {
                drawClearBevel( painter, x, y, w, h, group.button().dark( 110 ) );
            }
            else if ( raised )
            {
                drawClearBevel( painter, x, y, w, h, group.button() );
            }
            painter->setPen( group.text() );
            break;
        }
    case CC_Slider:
        {
            const QSlider* slider = ( const QSlider* ) widget;
            QRect groove = querySubControlMetrics( CC_Slider, widget, SC_SliderGroove, option );
            QRect handle = querySubControlMetrics( CC_Slider, widget, SC_SliderHandle, option );

            if ( slider->parentWidget() && ( slider->parentWidget() ->paletteBackgroundPixmap() && !slider->parentWidget() ->paletteBackgroundPixmap() ->isNull() ) )
            {
                const QPixmap * pixmap = slider->topLevelWidget() ->paletteBackgroundPixmap() ;
                if ( pixmap )
                {
                    QWidget * topLevelWidget = widget->topLevelWidget();
                    painter->drawTiledPixmap( rect, *pixmap, widget->mapTo( topLevelWidget, QPoint( 0, 0 ) ) );
                }
            }
            if ( ( controls & SC_SliderGroove ) && groove.isValid() )
            {
                drawKStylePrimitive( KPE_SliderGroove, painter, widget, groove, group, flags, option );
            }

            if ( ( controls & SC_SliderHandle ) && handle.isValid() )
            {
                if ( active == SC_SliderHandle )
                    flags |= Style_Active;
                drawKStylePrimitive( KPE_SliderHandle, painter, widget, handle, group, flags, option );
            }

            break;
        }

    default:
        KStyle::drawComplexControl( control, painter, widget, rect, group,
                                    flags, controls, active, option );
        break;
    }
}

//////////////////////////////////////////////////////////////////////////////
// drawComplexControlMask()
// ------------------------
// Draw a bitmask for the control

void Metal4kdeStyle::drawComplexControlMask( ComplexControl control,
        QPainter *painter,
        const QWidget *widget,
        const QRect &rect,
        const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "drawComplexControlMask()" );
#endif


    switch ( control )
    {
    case CC_ComboBox:
        //case CC_ToolButton:
        {
            painter->fillRect( rect, Qt::color1 );
            painter->setPen( Qt::color0 );
            break;
        }

    default:
        KStyle::drawComplexControlMask( control, painter, widget, rect, option );
    }
}


// QPixmap Metal4kdeStyle::stylePixmap( StylePixmap stylepixmap,
//                                   const QWidget* widget,
//                                   const QStyleOption& opt ) const
// {
//     return KStyle::stylePixmap( stylepixmap, widget, opt );
// }

//////////////////////////////////////////////////////////////////////////////
// pixelMetric()
// -------------
// Get the pixel metric for metric

int Metal4kdeStyle::pixelMetric( PixelMetric metric, const QWidget *widget ) const
{
#ifdef BACKTRACE
    qWarning( "pixelMetric()" );
#endif


    switch ( metric )
    {
        //       case PM_ToolBarItemSpacing:
        //             return 10;
    case PM_DefaultFrameWidth:
        {
            if ( widget && ::qt_cast<QPopupMenu*>( widget ) )
                return 1;
            else if ( widget && ::qt_cast<QComboBox*>( widget ) )
                return 4;
            else
                return KStyle::pixelMetric( metric, widget );
            //       case PM_PopupMenuFrameHorizontalExtra:
            //             return 20;
        }
    case PM_ButtonDefaultIndicator:                                                                              // size of default indicator
        return 2;

    case PM_ButtonMargin:                                                                                        // Space betweeen frame and label
        return 3;

    case PM_ExclusiveIndicatorWidth:                                                                             // radiobutton size
    case PM_ExclusiveIndicatorHeight:
        return 16;

    case PM_IndicatorWidth:                                                                                      // checkbox size
    case PM_IndicatorHeight:
        return 16;

    case PM_MenuButtonIndicator:                                                                                 // arrow width
        return 7;

    case PM_ScrollBarExtent:                                                                                     // extent of slider
        return ( 15 );
        break;

    case PM_ScrollBarSliderMin:                                                                                  // minimum length of slider
        return 30;

    case PM_SliderThickness:                                                                                     // slider thickness
    case PM_SliderControlThickness:
    case PM_SliderLength:
        return 13;

    case PM_SplitterWidth:                                                                                       // width of spitter
        return 6;

    case PM_TabBarTabOverlap:                                                                                    // Amount of tab overlap
    case PM_TabBarBaseOverlap:
        return 0;

    case PM_TabBarTabHSpace:                                                                                     // extra tab spacing
        return 30;

    case PM_TabBarTabVSpace:
        return 10;

    case PM_TabBarBaseHeight:
        return 5;
        break;

    default:
        return KStyle::pixelMetric( metric, widget );
    }
}

//////////////////////////////////////////////////////////////////////////////
// querySubControlMetrics()
// ------------------------
// Get metrics for subcontrols of complex controls

QRect Metal4kdeStyle::querySubControlMetrics( ComplexControl control,
        const QWidget *widget,
        SubControl subcontrol,
        const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "querySubControlMetrics()" );
#endif

    QRect rect;

    const int fw = pixelMetric( PM_DefaultFrameWidth, widget );
    int w = widget->width(), h = widget->height();
    int xc;

    switch ( control )
    {
    case CC_ComboBox:
        {
            xc = 20; // position between edit and arrow

            switch ( subcontrol )
            {
            case SC_ComboBoxFrame:                                                                            // total combobox area
                rect = widget->rect();
                break;

            case SC_ComboBoxArrow:                                                                            // the right side
                rect.setRect( w - xc, fw, xc - fw, h - ( fw * 2 ) );
                break;

            case SC_ComboBoxEditField:                                                                            // the left side
                rect.setRect( fw + 10, fw, w - xc - fw - 1 - 10, h - ( fw * 2 ) );
                break;

            case SC_ComboBoxListBoxPopup:                                                                            // the list popup box
                rect = option.rect();
                break;

            default:
                break;
            }
            break;
        }

    case CC_SpinWidget:
        {
            bool odd = widget->height() % 2;
            xc = 17; // position between edit and arrows

            switch ( subcontrol )
            {
            case SC_SpinWidgetButtonField:
                rect.setRect( w - xc, 1, xc - 1, h - 2 );
                break;

            case SC_SpinWidgetEditField:
                rect.setRect( fw, fw, w - xc - fw, h - ( fw * 2 ) );
                break;

            case SC_SpinWidgetFrame:
                rect = widget->rect();
                break;

            case SC_SpinWidgetUp:
                rect.setRect( w - xc, ( h / 2 ) - ( odd ? 6 : 7 ), xc - 1, 6 );
                break;

            case SC_SpinWidgetDown:
                rect.setRect( w - xc, ( h / 2 ) + 1, xc - 1, odd ? 7 : 6 );
                break;

            default:
                break;
            }
            break;
        }

    default:
        rect = KStyle::querySubControlMetrics( control, widget, subcontrol,
                                               option );
    }

    return rect;
}

//////////////////////////////////////////////////////////////////////////////
// sizeFromContents()
// ------------------
// Returns the size of widget based on the contentsize

QSize Metal4kdeStyle::sizeFromContents( ContentsType contents,
                                        const QWidget* widget,
                                        const QSize &contentsize,
                                        const QStyleOption &option ) const
{
#ifdef BACKTRACE
    qWarning( "sizeFromContents()" );
#endif


    int w = contentsize.width();
    int h = contentsize.height();

    switch ( contents )
    {
    case CT_ToolButton:
        {
            const QToolButton * button = dynamic_cast<const QToolButton*>( widget );
            if ( !button )
            {
                return KStyle::sizeFromContents( contents, widget, contentsize,
                                                 option );
            }
            int margin = pixelMetric( PM_ButtonMargin, widget )
                         + pixelMetric( PM_DefaultFrameWidth, widget );

            w += margin + 6;
            h += margin + 4;
            return QSize( w, h );
        }
    case CT_PushButton:
        {
            const QPushButton * button = dynamic_cast<const QPushButton*>( widget );
            if ( !button )
            {
                return KStyle::sizeFromContents( contents, widget, contentsize,
                                                 option );
            }
            int margin = pixelMetric( PM_ButtonMargin, widget )
                         + pixelMetric( PM_DefaultFrameWidth, widget ) + 4;

            w += margin + 6; // add room for bold font
            h += margin;

            // standard width and heights
            if ( button->isDefault() || button->autoDefault() )
            {
                if ( w < 80 && !button->pixmap() )
                    w = 80;
            }
            if ( h < 22 )
                h = 22;
            return QSize( w, h );
        }

    case CT_ComboBox:
        {
            QComboBox * combo = ( QComboBox* ) widget;

            if (combo->editable())
            {
                if ( h < 26 )
                    h = 26;
                if ( w < 60 )
                    w = 60;
                return QSize( w, h );
            }
            else
            {
                if ( h < 23 )
                    h = 23;
                if ( w < 70 )
                    w = 70;
                return QSize( w, h );
            }
            break;
        }

    case CT_PopupMenuItem:
        {
            if ( !widget || option.isDefault() )
                return contentsize;
            const QPopupMenu *popup = dynamic_cast<const QPopupMenu*>( widget );
            if ( !popup )
            {
                return KStyle::sizeFromContents( contents, widget, contentsize,
                                                 option );
            }
            QMenuItem *item = option.menuItem();

            if ( item->custom() )
            {
                w = item->custom() ->sizeHint().width();
                h = item->custom() ->sizeHint().height();
                if ( !item->custom() ->fullSpan() )
                    h += ITEMVMARGIN * 2 + ITEMFRAME * 2;
            }
            else if ( item->widget() )
            { // a menu item that is a widget
                w = contentsize.width();
                h = contentsize.height();
            }
            else if ( item->isSeparator() )
            {
                w = h = 3;
            }
            else
            {
                if ( item->pixmap() )
                {
                    h = QMAX( h, item->pixmap() ->height() + ITEMFRAME * 2 );
                }
                else
                {
                    h = QMAX( h, MINICONSIZE + ITEMFRAME * 2 );
                    h = QMAX( h, popup->fontMetrics().height()
                              + ITEMVMARGIN * 2 + ITEMFRAME * 2 );
                }
                if ( item->iconSet() )
                    h = QMAX( h, item->iconSet() ->
                              pixmap( QIconSet::Small, QIconSet::Normal ).height()
                              + ITEMFRAME * 2 );
            }

            if ( !item->text().isNull() && item->text().find( '\t' ) >= 0 )
                w += 12;
            else if ( item->popup() )
                w += 2 * ARROWMARGIN;

            if ( option.maxIconWidth() || popup->isCheckable() )
            {
                w += QMAX( option.maxIconWidth(),
                           QIconSet::iconSize( QIconSet::Small ).width() )
                     + ITEMHMARGIN * 2;
            }
            w += RIGHTBORDER;
            return QSize( w, h );
        }

    default:
        return KStyle::sizeFromContents( contents, widget, contentsize,
                                         option );
    }
}


int Metal4kdeStyle::styleHint ( StyleHint stylehint, const QWidget * widget, const QStyleOption & opt , QStyleHintReturn * returnData ) const
{
#ifdef BACKTRACE
    qWarning( "styleHint()" );
#endif
    switch ( stylehint )
    {
    case QStyle::SH_TabBar_Alignment:
        if ( optionsHandler_->centerTabs_ )
        {
            return AlignHCenter;
        }
        break;

    default:
        return KStyle::styleHint( stylehint, widget, opt, returnData );
    }
    return KStyle::styleHint( stylehint, widget, opt, returnData );
}

/******************/
/* private        */
/******************/


//////////////////////////////////////////////////////////////////////////////
// processEmbedded()
// -----------
//

QPixmap* Metal4kdeStyle::processEmbedded( const char *label, const QColor &fillColor, bool blend ) const
{
#ifdef BACKTRACE
    qWarning( "processEmbedded()" );
#endif

    QImage img( uic_findImage( label ) );
    img.detach();
    if ( img.isNull() )
    { // shouldn't happen, been tested
        //qWarning( "Invalid embedded label %s", label );
        return ( NULL );
    }
    return ( adjustHSV( img, fillColor, blend ) );
}

//////////////////////////////////////////////////////////////////////////////
// getPixmap()
// -----------
//

QPixmap* Metal4kdeStyle::getPixmap( BitmapData item ) const
{
#ifdef BACKTRACE
    qWarning( "getPixmap()" );
#endif
    QColorGroup group = qApp->palette().active();
    QColor bgColor ( group.background() );
    QColor btnColor( group.button() );
    QColor btnHoverColor( group.button().light( 120 ) );
    QColor scrollBarBg = Qt::gray;

    if ( pixmaps_[ item ] )
        return ( pixmaps_[ item ] );

    Metal4kdeStyle *ptr = const_cast<Metal4kdeStyle*>( this );

    switch ( item )
    {
        // chack boxes
    case CB:
        ptr->pixmaps_[ CB ] = processEmbedded( "checkbox", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomCBOff ] : bgColor );
        break;

    case CBHover:
        ptr->pixmaps_[ CBHover ] = processEmbedded( "checkbox", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomCBOn ] : btnColor);
        break;

    case CBDown:
        ptr->pixmaps_[ CBDown ] = processEmbedded( "checkboxdown", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomCBOn ] : btnColor);
        break;

    case CBDownHover:
        ptr->pixmaps_[ CBDownHover ] = processEmbedded( "checkboxdown", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomCBOn ].light( 125 ) : btnHoverColor );
        break;


        // radio buttons
    case RadioOff:
        ptr->pixmaps_[ RadioOff ] = processEmbedded( "radio", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomRadioOff ] : bgColor);
        break;

    case RadioOffHover:
        ptr->pixmaps_[ RadioOffHover ] = processEmbedded( "radio", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomRadioOn ] : btnColor );
        break;

    case RadioOn:
        ptr->pixmaps_[ RadioOn ] = processEmbedded( "radio_down", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomRadioOn ] : btnColor );
        break;

    case RadioOnHover:
        ptr->pixmaps_[ RadioOnHover ] = processEmbedded( "radio_down", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomRadioOn ].light( 125 ) : btnHoverColor );
        break;

        // FIXME
    case HTMLRadioOff:
        ptr->pixmaps_[ HTMLRadioOff ] = processEmbedded( "htmlradio", btnColor, &bgColor );
        break;

        // FIXME
        // tabs
    case TabLeft:
        ptr->pixmaps_[ TabLeft ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOff ] : bgColor );
        break;

    case TabLeftDown:
        ptr->pixmaps_[ TabLeftDown ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        break;

    case TabLeftOver:
        ptr->pixmaps_[ TabLeftOver ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        break;

    case TabRight:
        ptr->pixmaps_[ TabRight ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOff ] : bgColor );
        break;

    case TabRightDown:
        ptr->pixmaps_[ TabRightDown ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        break;

    case TabRightOver:
        ptr->pixmaps_[ TabRightOver ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        break;

    case belowTabLeft:
        ptr->pixmaps_[ belowTabLeft ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOff ] : bgColor );
        *ptr->pixmaps_[ belowTabLeft ] = ptr->pixmaps_[ belowTabLeft ] ->xForm( iMatrix_ );
        break;

    case belowTabLeftDown:
        ptr->pixmaps_[ belowTabLeftDown ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        *ptr->pixmaps_[ belowTabLeftDown ] = ptr->pixmaps_[ belowTabLeftDown ] ->xForm( iMatrix_ );
        break;

    case belowTabLeftOver:
        ptr->pixmaps_[ belowTabLeftOver ] = processEmbedded( "tabL", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        *ptr->pixmaps_[ belowTabLeftOver ] = ptr->pixmaps_[ belowTabLeftOver ] ->xForm( iMatrix_ );
        break;

    case belowTabRight:
        ptr->pixmaps_[ belowTabRight ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOff ] : bgColor );
        *ptr->pixmaps_[ belowTabRight ] = ptr->pixmaps_[ belowTabRight ] ->xForm( iMatrix_ );
        break;

    case belowTabRightDown:
        ptr->pixmaps_[ belowTabRightDown ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        *ptr->pixmaps_[ belowTabRightDown ] = ptr->pixmaps_[ belowTabRightDown ] ->xForm( iMatrix_ );
        break;

    case belowTabRightOver:
        ptr->pixmaps_[ belowTabRightOver ] = processEmbedded( "tabR", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        *ptr->pixmaps_[ belowTabRightOver ] = ptr->pixmaps_[ belowTabRightOver ] ->xForm( iMatrix_ );
        break;

    case tabBase:
        ptr->pixmaps_[ tabBase ] = processEmbedded( "tabBase", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomTabOn ] : btnColor );
        break;


        // sliders handel's
    case HSlider:
        ptr->pixmaps_[ HSlider ] = processEmbedded( "sliderarrow", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomSliderHandleOff ] : btnColor );
        break;

    case HSliderOver:
        ptr->pixmaps_[ HSliderOver ] = processEmbedded( "sliderarrow", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomSliderHandleOn ] : btnHoverColor );
        break;

    case VSlider:
        ptr->pixmaps_[ VSlider ] = processEmbedded( "sliderarrow", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomSliderHandleOff ] : btnColor );
        *ptr->pixmaps_[ VSlider ] = ptr->pixmaps_[ VSlider ] ->xForm( rMatrix_ );
        break;

    case VSliderOver:
        ptr->pixmaps_[ VSliderOver ] = processEmbedded( "sliderarrow", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomSliderHandleOn ] : btnHoverColor );
        *ptr->pixmaps_[ VSliderOver ] = ptr->pixmaps_[ VSliderOver ] ->xForm( rMatrix_ );
        break;

        // FIXME
        // scroll bar sliders
    case VSBSliderTop:
        ptr->pixmaps_[ VSBSliderTop ] = processEmbedded( "sbslider_top", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        break;

        //     case VSBSliderTopHover:
        //         ptr->pixmaps_[ VSBSliderTopHover ] = processEmbedded( "sbslider_top", btnHoverColor.light(120), &bgColor );
        //         break;

    case VSBSliderMid:
        ptr->pixmaps_[ VSBSliderMid ] = processEmbedded( "sbslider_mid", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        break;

        //     case VSBSliderMidHover:
        //         if(ptr->pixmaps_[ VSBSliderMidHover ])
        //             delete pixmaps_[ VSBSliderMidHover ];
        //         ptr->pixmaps_[ VSBSliderMidHover ] = processEmbedded( "sbslider_mid",*col /*btnHoverColor.light(120)*/, &bgColor );
        //         break;

    case VSBSliderBtm:
        ptr->pixmaps_[ VSBSliderBtm ] = processEmbedded( "sbslider_btm", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        break;

        //     case VSBSliderBtmHover:
        //         ptr->pixmaps_[ VSBSliderBtmHover ] = processEmbedded( "sbslider_btm", btnHoverColor.light(120), &bgColor );
        //         break;

    case HSBSliderTop:
        ptr->pixmaps_[ HSBSliderTop ] = processEmbedded( "sbslider_top", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        *ptr->pixmaps_[ HSBSliderTop ] = ptr->pixmaps_[ HSBSliderTop ] ->xForm( rMatrix_ );
        break;

        //     case HSBSliderTopHover:
        //         ptr->pixmaps_[ HSBSliderTopHover ] = processEmbedded( "sbslider_top", btnHoverColor.light(120), &bgColor );
        //         *ptr->pixmaps_[ HSBSliderTopHover ] = ptr->pixmaps_[ HSBSliderTopHover ] ->xForm( rMatrix_ );
        //         break;

    case HSBSliderMid:
        ptr->pixmaps_[ HSBSliderMid ] = processEmbedded( "sbslider_mid", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        *ptr->pixmaps_[ HSBSliderMid ] = ptr->pixmaps_[ HSBSliderMid ] ->xForm( rMatrix_ );
        break;

        //     case HSBSliderMidHover:
        //         ptr->pixmaps_[ HSBSliderMidHover ] = processEmbedded( "sbslider_mid", btnHoverColor.light(120), &bgColor );
        //         *ptr->pixmaps_[ HSBSliderMidHover ] = ptr->pixmaps_[ HSBSliderMidHover ] ->xForm( rMatrix_ );
        //         break;

    case HSBSliderBtm:
        ptr->pixmaps_[ HSBSliderBtm ] = processEmbedded( "sbslider_btm", optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomScrollBarSliderOff ] : btnHoverColor, FALSE );
        *ptr->pixmaps_[ HSBSliderBtm ] = ptr->pixmaps_[ HSBSliderBtm ] ->xForm( rMatrix_ );
        break;

        //     case HSBSliderBtmHover:
        //         ptr->pixmaps_[ HSBSliderBtmHover ] = processEmbedded( "sbslider_btm", btnHoverColor.light(120), &bgColor );
        //         *ptr->pixmaps_[ HSBSliderBtmHover ] = ptr->pixmaps_[ HSBSliderBtmHover ] ->xForm( rMatrix_ );
        //         break;


        // scroll bar sliders backgrounds
    case VSBSliderTopBg:
        ptr->pixmaps_[ VSBSliderTopBg ] = processEmbedded( "sbgroove_top", bgColor, FALSE);
        break;

    case VSBSliderMidBg:
        ptr->pixmaps_[ VSBSliderMidBg ] = processEmbedded( "sbgroove_mid", bgColor, FALSE );
        break;

    case VSBSliderBtmBg:
        ptr->pixmaps_[ VSBSliderBtmBg ] = processEmbedded( "sbgroove_btm", bgColor, FALSE );
        break;

    case HSBSliderTopBg:
        ptr->pixmaps_[ HSBSliderTopBg ] = processEmbedded( "sbgroove_top", bgColor, FALSE );
        *ptr->pixmaps_[ HSBSliderTopBg ] = ptr->pixmaps_[ HSBSliderTopBg ] ->xForm( rMatrix_ );
        break;

    case HSBSliderMidBg:
        ptr->pixmaps_[ HSBSliderMidBg ] = processEmbedded( "sbgroove_mid", bgColor, FALSE );
        *ptr->pixmaps_[ HSBSliderMidBg ] = ptr->pixmaps_[ HSBSliderMidBg ] ->xForm( rMatrix_ );
        break;

    case HSBSliderBtmBg:
        ptr->pixmaps_[ HSBSliderBtmBg ] = processEmbedded( "sbgroove_btm", bgColor, FALSE );
        *ptr->pixmaps_[ HSBSliderBtmBg ] = ptr->pixmaps_[ HSBSliderBtmBg ] ->xForm( rMatrix_ );
        break;


        // scroll buttons
    case scrollbuttonH:
        ptr->pixmaps_[ scrollbuttonH ] = processEmbedded( "scrollbuttonH", bgColor, FALSE );
        //*ptr->pixmaps_[ HSBSliderTopBg ] = ptr->pixmaps_[ HSBSliderTopBg ] ->xForm( rMatrix_ );
        break;

    case scrollbuttonV:
        ptr->pixmaps_[ scrollbuttonV ] = processEmbedded( "scrollbuttonV", bgColor, FALSE );
        //*ptr->pixmaps_[ HSBSliderTopBg ] = ptr->pixmaps_[ HSBSliderTopBg ] ->xForm( rMatrix_ );
        break;

        // progress bar
    case Progress:
        ptr->pixmaps_[ Progress ] = processEmbedded( "progress", btnColor.light(120), FALSE );
        break;

    case ProgressL:
        ptr->pixmaps_[ ProgressL ] = processEmbedded( "progressL", btnColor.light(120), FALSE );
        break;

    case ProgressM:
        ptr->pixmaps_[ ProgressM ] = processEmbedded( "progressM", btnColor.light(120), FALSE );
        break;

    case ProgressR:
        ptr->pixmaps_[ ProgressR ] = processEmbedded( "progressR", btnColor.light(120), FALSE );
        break;

    case ProgressH:
        ptr->pixmaps_[ ProgressH ] = processEmbedded( "progressH", bgColor, FALSE );
        break;

        // clear fills
    case HclearFillLargeButtonColor:
        ptr->pixmaps_[ HclearFillLargeButtonColor ] = processEmbedded( "clearFillSmall", btnColor, FALSE );

        break;

    case HclearFillLargeBackgroundColor:
        ptr->pixmaps_[ HclearFillLargeBackgroundColor ] = processEmbedded( "clearFillSmall", bgColor, FALSE );

        break;

    case VclearFillLargeButtonColor:
        ptr->pixmaps_[ VclearFillLargeButtonColor ] = processEmbedded( "clearFillSmall", btnColor, FALSE );
        *ptr->pixmaps_[ VclearFillLargeButtonColor ] = ptr->pixmaps_[ VclearFillLargeButtonColor ] ->xForm( rMatrix_ );
        break;

    case VclearFillLargeBackgroundColor:
        ptr->pixmaps_[ VclearFillLargeBackgroundColor ] = processEmbedded( "clearFillSmall", bgColor, FALSE );
        *ptr->pixmaps_[ VclearFillLargeBackgroundColor ] = ptr->pixmaps_[ VclearFillLargeBackgroundColor ] ->xForm( rMatrix_ );
        break;

        // defaults
    default:
        break;
    }
    return ( pixmaps_[ item ] );
}


//////////////////////////////////////////////////////////////////////////////
// flatToolbar()
// -------------
// Is the toolbar "flat"
bool Metal4kdeStyle::flatToolbar( const QToolBar *toolbar ) const
{
#ifdef BACKTRACE
    qWarning( "flatToolbar()" );
#endif

    if ( toolbar->place() == QDockWindow::OutsideDock )
        return true;
    if ( !toolbar->mainWindow() )
        return true;
    return ( !toolbar->mainWindow() ->dockWindowsMovable() );
}

//////////////////////////////////////////////////////////////////////////////
// updateProgressPos()
// -------------
//
inline void Metal4kdeStyle::updateProgressPos()
{
#ifdef BACKTRACE
    qWarning( "updateProgressPos()" );
#endif

    progAnimShift_++;
    if ( progAnimShift_ == 20 )
        progAnimShift_ = 0;
    ////qWarning( "%d", progAnimShift_ );
    //emit animate(false);
}

//////////////////////////////////////////////////////////////////////////////
// updateProgressPos()
// -------------
//
inline void Metal4kdeStyle::updateScrollBar()
{
#ifdef BACKTRACE
    qWarning( "updateScrollBar()" );
#endif

    scrollBarMovementmShift_ ++;
    if(scrollBarMovementmShift_ >= 30)
        scrollBarMovementmShift_ = 0;

    scrollBarStartNum_ += scrollBarAnimShift_;
    if ( scrollBarStartNum_ <= 120 || scrollBarStartNum_ >= 170 )
        scrollBarAnimShift_ *= -1;
    ////qWarning( "%d", scrollBarStartNum_ );
    emit animate( false );
}


/****************************************************************************/
/******end class meatal                                               *******/
/****************************************************************************/







/****************************************************************************/
/* Plugin Stuff                                                             */
/****************************************************************************/


class Metal4kdeStylePlugin : public QStylePlugin
{
public:
    Metal4kdeStylePlugin();
    QStringList keys() const;
    QStyle *create( const QString &key );
};

Metal4kdeStylePlugin::Metal4kdeStylePlugin() : QStylePlugin()
{
#ifdef BACKTRACE
    qWarning( "Metal4kdeStylePlugin()" );
#endif

    ;
}

QStringList Metal4kdeStylePlugin::keys() const
{
#ifdef BACKTRACE
    qWarning( "keys()" );
#endif

    return QStringList() << "Metal4kde";
}

QStyle* Metal4kdeStylePlugin::create( const QString& key )
{
#ifdef BACKTRACE
    qWarning( "create()" );
#endif

    if ( key.lower() == "metal4kde" )
        return new Metal4kdeStyle();
    return 0;
}

Q_EXPORT_PLUGIN( Metal4kdeStylePlugin );


/****************************************************************************/
/* end Plugin Stuff                                                         */
/****************************************************************************/


#include "Metal4kde.moc"
