/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef Metal4kdeSTYLE_H
#define Metal4kdeSTYLE_H

#include <kstyle.h>
#include <qcolor.h>
#include <qintdict.h>

#include <kdrawutil.h>
#include <kpixmap.h>
#include <kpixmapeffect.h>

#include <qapplication.h>
#include <qintdict.h>
#include <qpainter.h>
#include <qpointarray.h>
#include <qsettings.h>
#include <qstyleplugin.h>

#include <qobjectlist.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qmainwindow.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qscrollbar.h>
#include <qslider.h>
#include <qtabbar.h>
#include <qtabwidget.h>
#include <qtoolbar.h>
#include <qtoolbox.h>
#include <qtoolbutton.h>
#include <qimage.h>
#include <qtimer.h>
#include <qscrollview.h>
#include <qptrdict.h>
#include <qdict.h>
#include <stdio.h>

//#define BACKTRACE

//static const char* QTOOLBAREXTENSION = "QToolBarExtensionWidget";
//static const char* KTOOLBARWIDGET = "kde toolbar widget";
//static const QColor BGCOLOR = QColor( 150, 150, 150 );


// some convenient constants
static const int ITEMFRAME = 1; // menu stuff
static const int ITEMHMARGIN = 3;
static const int ITEMVMARGIN = 0;
static const int ARROWMARGIN = 6;
static const int RIGHTBORDER = 6;
static const int MINICONSIZE = 16;
static const int CHECKSIZE = 9;
static const int MAXGRADIENTSIZE = 64;

//static unsigned contrast = 110;



class KPixmap;
class Metal4kdeStyle;


enum Tile{TileTopLeft = 0, TileTop, TileTopRight,
          TileLeft, TileMiddle, TileRight, TileBtmLeft, TileBtm, TileBtmRight};

enum BitmapData{
    // chack_ boxes
    CB = 0, CBHover, CBDown, CBDownHover,
    // radio buttons
    RadioOff, RadioOffHover, RadioOn, RadioOnHover,
    HTMLRadioOff,
    // tabs
    TabLeft, TabLeftDown, TabLeftOver ,TabRight, TabRightDown, TabRightOver,
    belowTabLeft, belowTabLeftDown, belowTabLeftOver ,belowTabRight, belowTabRightDown, belowTabRightOver, tabBase,
    // slider handel's
    HSlider, HSliderOver, VSlider, VSliderOver,
    // sliders
    HSBSliderTop, HSBSliderTopHover, HSBSliderMid, HSBSliderMidHover, HSBSliderBtm, HSBSliderBtmHover, VSBSliderTop, VSBSliderTopHover, VSBSliderMid, VSBSliderMidHover, VSBSliderBtm, VSBSliderBtmHover, scrollbutton,
    // scroll bar sliders backgrounds
    VSBSliderTopBg, VSBSliderMidBg, VSBSliderBtmBg,
    HSBSliderTopBg, HSBSliderMidBg, HSBSliderBtmBg,
    // scroll buttons
    scrollbuttonH, scrollbuttonV,
    // progress bar
    Progress, ProgressL, ProgressM, ProgressR, ProgressH,
    // clear fills
    clearFillLargeImg,clearFillSmallImg,
    HclearFillLargeButtonColor, HclearFillLargeBackgroundColor, VclearFillLargeButtonColor, VclearFillLargeBackgroundColor,
    // count
    BitmapDataCount

};

enum CustomColor{CustomTabOff = 0, CustomTabOn,
                 CustomRadioOff, CustomRadioOn, CustomCBOff, CustomCBOn,
                 CustomScrollBarSliderOff, CustomScrollBarSliderOn,
                 CustomSliderHandleOff, CustomSliderHandleOn,
                 CustomButtonOff, CustomButtonOn, CustomWidgetBorderColor, CustomBrushedMetal
                };



/****************************************************************************/
/****** class ButtonTile                                              *******/
/****************************************************************************/

class ButtonTile
{
public:
    ButtonTile()
    {
        for ( int i = 0;i < 9; i++ )
        {
            pixmaps_[ i ] = NULL;
        }
        ;
    }
    ~ButtonTile()
    {
        for ( int i = 0;i < 9; i++ )
        {
            if ( pixmaps_[ i ] )
                delete pixmaps_[ i ];
        }
        ;
    }
    QPixmap* pixmap( Tile pos )
    {
        return ( pixmaps_[ ( int ) pos ] );
    }
    void setPixmap( Tile pos, QPixmap *pix )
    {
        pixmaps_[ ( int ) pos ] = pix;
    }
protected:
    QPixmap *pixmaps_[ 9 ];
};

/****************************************************************************/
/******end class ButtonTile                                           *******/
/****************************************************************************/






/****************************************************************************/
/****** class optionsHandler                                          *******/
/****************************************************************************/

class optionsHandler : public QObject
{
public:
    optionsHandler( QObject *parent );
    ~optionsHandler();
    void reloadSettings();
    void setColors();

public:
    bool centerTabs_, enableHarderLightning_,highlights_, enableAnimate_, enableFullcycle_, useCustomColors_;
    int enterAnimateTiming_,leaveAnimateTiming_, animateTolerance_, coloringAmount_;

    QColor customColors_[ 14 ];
};

/****************************************************************************/
/****** end class optionsHandler                                      *******/
/****************************************************************************/






/****************************************************************************/
/****** class animationWidget                                          *******/
/****************************************************************************/

class animationWidget : public QObject
{
    Q_OBJECT
public:
    animationWidget( Metal4kdeStyle *parent, QWidget *widget , optionsHandler *options);
    ~animationWidget();
    void startAnimation();

public slots:
    void animate();
    void animateProgressBar();

public:
    int animProgress_;
    bool flag_, hover_;
    QWidget *animWidget_;
    Metal4kdeStyle *parent_;
    optionsHandler *options_;
    QTimer *animTimer_;
};

/****************************************************************************/
/****** end class animationWidget                                      *******/
/****************************************************************************/





/****************************************************************************/
/****** class meatal                                                  *******/
/****************************************************************************/

class Metal4kdeStyle : public KStyle
{
    Q_OBJECT

public:
    Metal4kdeStyle();
    virtual ~Metal4kdeStyle();

    void polish( QApplication* app );

    void polish( QWidget *widget );

    void polish( QPalette &pal );

    void unPolish( QWidget *widget );

    void drawPrimitive( PrimitiveElement element, QPainter *painter, const QRect &rect, const QColorGroup &group, SFlags flags = Style_Default, const QStyleOption &option = QStyleOption::Default ) const;

    void drawKStylePrimitive( KStylePrimitive element, QPainter *painter, const QWidget *widget, const QRect &rect, const QColorGroup &group, SFlags flags = Style_Default, const QStyleOption &option = QStyleOption::Default ) const;

    void drawControl( ControlElement element, QPainter *painter, const QWidget *widget, const QRect &rect, const QColorGroup &group, SFlags flags = Style_Default, const QStyleOption &option = QStyleOption::Default ) const;

    void drawControlMask( ControlElement element, QPainter *painter, const QWidget *widget, const QRect &rect, const QStyleOption &option = QStyleOption::Default ) const;

    void drawComplexControl( ComplexControl control, QPainter *painter, const QWidget *widget, const QRect &rect, const QColorGroup &group, SFlags flags = Style_Default, SCFlags controls = SC_All, SCFlags active = SC_None, const QStyleOption &option = QStyleOption::Default ) const;

    void drawComplexControlMask( ComplexControl control, QPainter *painter, const QWidget *widget, const QRect &rect, const QStyleOption &option = QStyleOption::Default ) const;

    int pixelMetric( PixelMetric metric, const QWidget *widget = 0 ) const;

    QRect querySubControlMetrics( ComplexControl control, const QWidget *widget, SubControl subcontrol, const QStyleOption &option = QStyleOption::Default ) const;

    QSize sizeFromContents( ContentsType contents, const QWidget *widget, const QSize &contentsize, const QStyleOption& option = QStyleOption::Default ) const;

    //     		QPixmap stylePixmap( StylePixmap stylepixmap, const QWidget *widget = 0, const QStyleOption& = QStyleOption::Default ) const;

    bool eventFilter( QObject *object, QEvent *event );

public slots:
    void updateProgressPos();
    void updateScrollBar();

private:
    Metal4kdeStyle( const Metal4kdeStyle & );
    Metal4kdeStyle& operator=( const Metal4kdeStyle & );

    ButtonTile* separateTiles( QPixmap *pix, int leftCornerTileWidth, int midTilesWidth, int rightCornerTileWidth, int upCornerTileHeight, int midTilesHeight, int downCornerTileHeight ) const;

    QPixmap* adjustHSV( QImage &img, const QColor &c, bool blend = TRUE ) const;

    QImage* adjustHSVImage( QImage &img, const QColor &c, bool blend ) const;

    QPixmap* processEmbedded( const char *label, const QColor &fillColor, bool blend = TRUE ) const;

    QPixmap* getPixmap( BitmapData item) const;

    void drawClearBevel( QPainter *p, int x, int y, int w, int h, const QColor fillColor, bool isPopUp = FALSE ) const;

    void drawSeperetedTiles( QPainter *p, ButtonTile *tile, int leftCornerTileWidth, int rightCornerTileWidth, int upCornerTileHeight, int downCornerTileHeight, int w, int h ) const ;

    void drawEditFrame( QPainter *painter, const QRect &rect, const QColorGroup &group ) const;

    void drawMetalButton( QPainter *painter, int x, int y, int w, int h, const QColorGroup &group, const QColor &fill, bool isHTMLButton_, bool sunken = FALSE , int bgX = -1, int bgY = -1 ) const;

    void drawMetalCombo(const QComboBox * combo, QPainter *painter,bool mouseHover, SCFlags controls,  const QRect &rect, const QColor &fill,bool isHTMLButton_, const QColorGroup &group, int x, int y, SFlags flags, SCFlags active)const;

    bool isHTMLWidget( const QWidget *widget ) const;

    bool flatToolbar( const QToolBar *toolbar ) const;

    void prepareBacckground( QWidget *widget );

    void showWidgetInformation( QWidget *widget );

    int styleHint ( StyleHint stylehint, const QWidget * widget = 0, const QStyleOption & opt = QStyleOption::Default, QStyleHintReturn * returnData = 0 ) const;

signals:
    void animate( bool );

public:
    int progAnimShift_;

private:
    int  scrollBarAnimShift_, scrollBarStartNum_, scrollBarMovementmShift_, headerHoverID_, qtrcModificationTime_;

    bool reverse_, kicker_, konqueror_,kdesktop_, isHTMLButton_, shouldColorize_, initialPaletteLoaded_;

    QWidget *hover_;

    QPoint btnOffset_;

    QScrollBar *currentScrollBar_;

    QWMatrix rMatrix_, iMatrix_;

    QTimer *scrollBarTimer_;

    QHeader *currentHeader_;

    optionsHandler *optionsHandler_;

    QPalette polishedPalette_, tooltipPalette_;

    QIntDict<ButtonTile>btnDict_;
    QIntDict<ButtonTile>btnWebDict_;
    QIntDict<ButtonTile>clearFillLargeDict_;
    QIntDict<ButtonTile>clearFillSmallDict_;
    QIntDict<QPixmap>verScrollBarTopDict_;
    QIntDict<QPixmap>verScrollBarMidDict_;
    QIntDict<QPixmap>verScrollBarBtmDict_;
    QIntDict<QPixmap>horScrollBarTopDict_;
    QIntDict<QPixmap>horScrollBarMidDict_;
    QIntDict<QPixmap>horScrollBarBtmDict_;
    QDict<animationWidget> animationWidgetDict_;

    QImage *buttonImg_, *buttonWebImg_, *clearFillSmallImg_, *clearFillLargeImg_, *verScrollBarTopImg_, *verScrollBarMidImg_, *verScrollBarBtmImg_, *horScrollBarTopImg_, *horScrollBarMidImg_, *horScrollBarBtmImg_, *editBoxImg_;

    QPixmap *pixmaps_[ BitmapDataCount ], sbBuffer_, *brushedMetalPix_, *brushedMetalLightningPix_, *menuLeftPix_, *menuRightPix_, *editBoxPix_;
};

/****************************************************************************/
/******end class meatal                                               *******/
/****************************************************************************/



#endif // Metal4kdeSTYLE_H
