/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Metal4kde.h"


animationWidget::animationWidget( Metal4kdeStyle *parent, QWidget *widget , optionsHandler *options)
{
#ifdef BACKTRACE
    qWarning( "animationWidget()" );
#endif

    hover_ = true;
    flag_ = true;
    animWidget_ = ( QWidget* ) widget;
    parent_ = parent;
    options_ = options;
    animProgress_ = 100 + options_->animateTolerance_;

    animTimer_ = new QTimer(widget);

    if(widget->inherits("QProgressBar"))
        connect( animTimer_, SIGNAL( timeout() ), this, SLOT( animateProgressBar() ) );
    else
        connect( animTimer_, SIGNAL( timeout() ), this, SLOT( animate() ) );

    startAnimation();
}


animationWidget::~animationWidget()
{
#ifdef BACKTRACE
    qWarning( "~animationWidget()" );
#endif
    //delete animTimer_;
}

void animationWidget::startAnimation()
{
    if(animWidget_->inherits("QProgressBar"))
    {
        if(animTimer_)
            animTimer_->start( 50 );
    }
    else
    {
        if(animTimer_)
            animTimer_->start( 1 );
    }
}

void animationWidget::animate( )
{
#ifdef BACKTRACE
    qWarning( "animate()" );
#endif

    if(animTimer_)
    {
        animTimer_->stop();
        if ( hover_  && flag_ )
        {
            if ( animProgress_ >= 100 )
            {
                animProgress_-= 2;
                if(animTimer_)
                {
                    animWidget_->repaint( false );
                    animTimer_->start( options_->enterAnimateTiming_, true ); // single-shot
                }
            }
        }
        else
        {
            if ( animProgress_ <= 100 + options_->animateTolerance_ )
            {
                animProgress_+= 2;
                if(animTimer_)
                {
                    animWidget_->repaint( false );
                    animTimer_->start( options_->leaveAnimateTiming_, true ); // single-shot
                }
            }
            else
            {
                hover_ =false;
                if(animTimer_)
                {
                    animWidget_->repaint( false );
                }

            }
        }
        //qWarning( "%d", animProgress_ );
    }
}

void animationWidget::animateProgressBar()
{
    parent_->progAnimShift_--;
    if ( parent_->progAnimShift_ == 0 )
        parent_->progAnimShift_ = 46;
    //qWarning( "%d", parent_->progAnimShift_ )
    if(animTimer_)
    {
        animWidget_->repaint( false );
    }
}

