/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qsettings.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qwhatsthis.h>
#include <klocale.h>
#include <kglobal.h>
#include <kcolorbutton.h>
#include <qspinbox.h>

#include "Metal4kdestyleconfig.h"
#include "styledialog.h"

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyleConfig Class                                                    //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyleConfig()
// ----------------
// Constructor

Metal4kdeStyleConfig::Metal4kdeStyleConfig( QWidget* parent ) : StyleDialog( parent )
{
#ifdef BACKTRACE
    qWarning( "Metal4kdeStyleConfig()" );
#endif

    KGlobal::locale() ->insertCatalogue( "kstyle_Metal4kde_config" );

    QSettings settings;

    // misc
    // style settings
    centerTabs->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/centerTabs", FALSE ) );
    connect( centerTabs, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );

    EnableHarderLightningCB->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/EnableHarderLightning", FALSE ) );
    connect( EnableHarderLightningCB, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );

    // highlightning stuff
    enableFullCycleCB->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/enableFullCycle", FALSE ) );
    connect( enableFullCycleCB, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );

    highlights->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/highlights", FALSE ) );
    connect( highlights, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );
    //connect( highlights, SIGNAL( toggled( bool ) ), this, SLOT( enableAnimateOrHighlightStateChange() ) );

    enableAnimateCB->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/enableAnimate", FALSE ) );
    connect( enableAnimateCB, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );
    //connect( enableAnimateCB, SIGNAL( toggled( bool ) ), this, SLOT( enableAnimateOrHighlightStateChange() ) );

    enterAnimateTimingSB ->setValue ( settings.readNumEntry( "/Metal4kdestyle/Settings/enterAnimateTiming", 5 ) );
    connect( enterAnimateTimingSB, SIGNAL( valueChanged( int ) ), this, SLOT( updateChanged() ) );

    leaveAnimateTimingSB ->setValue ( settings.readNumEntry( "/Metal4kdestyle/Settings/leaveAnimateTiming", 20 ) );
    connect( leaveAnimateTimingSB, SIGNAL( valueChanged( int ) ), this, SLOT( updateChanged() ) );

    animateTolaranceSB ->setValue ( settings.readNumEntry( "/Metal4kdestyle/Settings/animateTolarance", 50 ) );
    connect( animateTolaranceSB, SIGNAL( valueChanged( int ) ), this, SLOT( updateChanged() ) );



    // custom colors
    // widgets
    cbUseCustomColors->setChecked( settings.readBoolEntry( "/Metal4kdestyle/Settings/useCustomColors", FALSE ) );
    connect( cbUseCustomColors, SIGNAL( toggled( bool ) ), this, SLOT( updateChanged() ) );

    kcbTabOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/tabOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbTabOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbTabOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/tabOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbTabOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbRadioButonOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/radioOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbRadioButonOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbRadioButtonOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/radioOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbRadioButtonOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbChackBoxOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/chackBoxOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbChackBoxOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbChackBoxOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/chackBoxOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbChackBoxOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbScrollBarSliderOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/scrollBarSliderOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbScrollBarSliderOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbScrollBarSliderOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/scrollBarSliderOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbScrollBarSliderOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbSliderHandleOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/sliderHandleOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbSliderHandleOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbSliderHandleOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/sliderHandleOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbSliderHandleOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );


    kcbButtonOff->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/buttonOffColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbButtonOff, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbButtonOn->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/buttonOnColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbButtonOn, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    // other widgets
    kcbWidgetsBorderColor->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/WidgetsBorderColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbWidgetsBorderColor, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    kcbBrushedMetalColor->setColor( QColor( settings.readNumEntry( "/Metal4kdestyle/Settings/BrushedMetalColor", ( int ) colorGroup().background().rgb() ) ) );
    connect( kcbBrushedMetalColor, SIGNAL( changed( const QColor & ) ), this, SLOT( updateChanged() ) );

    // others
    coloringAmountSB ->setValue ( settings.readNumEntry( "/Metal4kdestyle/Settings/coloringAmount", 50 ) );
    connect( coloringAmountSB, SIGNAL( valueChanged( int ) ), this, SLOT( updateChanged() ) );


}

//////////////////////////////////////////////////////////////////////////////
// ~Metal4kdeStyleConfig()
// -----------------
// Destructor

Metal4kdeStyleConfig::~Metal4kdeStyleConfig()
{
#ifdef BACKTRACE
    qWarning( "~Metal4kdeStyleConfig()" );
#endif

    //KGlobal::locale() ->removeCatalogue( "kstyle_Metal4kde_config" );
}

//////////////////////////////////////////////////////////////////////////////
// selectionChanged()
// ------------------
// Selection has changed

void Metal4kdeStyleConfig::updateChanged()
{
#ifdef BACKTRACE
    qWarning( "updateChanged()" );
#endif

    emit changed( TRUE );
}


//////////////////////////////////////////////////////////////////////////////
// save()
// ------
// Save the settings

void Metal4kdeStyleConfig::save()
{
#ifdef BACKTRACE
    qWarning( "save()" );
#endif

    QSettings settings;

    // misc
    // style settings
    settings.writeEntry( "/Metal4kdestyle/Settings/centerTabs", centerTabs->isChecked() );
    settings.writeEntry( "/Metal4kdestyle/Settings/EnableHarderLightning", EnableHarderLightningCB->isChecked() );

    // highlightning stuff
    settings.writeEntry( "/Metal4kdestyle/Settings/highlights", highlights->isChecked() );
    settings.writeEntry( "/Metal4kdestyle/Settings/enableAnimate", enableAnimateCB->isChecked() );
    settings.writeEntry( "/Metal4kdestyle/Settings/enableFullCycle", enableFullCycleCB->isChecked() );
    settings.writeEntry( "/Metal4kdestyle/Settings/enterAnimateTiming", ( int ) enterAnimateTimingSB->value() );
    settings.writeEntry( "/Metal4kdestyle/Settings/leaveAnimateTiming", ( int ) leaveAnimateTimingSB->value() );
    settings.writeEntry( "/Metal4kdestyle/Settings/animateTolarance", ( int ) animateTolaranceSB->value() );


    // custom colors
    // widgets
    settings.writeEntry( "/Metal4kdestyle/Settings/useCustomColors", cbUseCustomColors->isChecked() );
    settings.writeEntry( "/Metal4kdestyle/Settings/tabOffColor", ( int ) kcbTabOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/tabOnColor", ( int ) kcbTabOn->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/radioOffColor", ( int ) kcbRadioButonOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/radioOnColor", ( int ) kcbRadioButtonOn->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/chackBoxOffColor", ( int ) kcbChackBoxOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/chackBoxOnColor", ( int ) kcbChackBoxOn->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/scrollBarSliderOffColor", ( int ) kcbScrollBarSliderOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/scrollBarSliderOnColor", ( int ) kcbScrollBarSliderOn->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/sliderHandleOffColor", ( int ) kcbSliderHandleOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/sliderHandleOnColor", ( int ) kcbSliderHandleOn->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/buttonOffColor", ( int ) kcbButtonOff->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/buttonOnColor", ( int ) kcbButtonOn->color().rgb() );
    // other widgets
    settings.writeEntry( "/Metal4kdestyle/Settings/WidgetsBorderColor", ( int ) kcbWidgetsBorderColor->color().rgb() );
    settings.writeEntry( "/Metal4kdestyle/Settings/BrushedMetalColor", ( int ) kcbBrushedMetalColor->color().rgb() );
    //others
    settings.writeEntry( "/Metal4kdestyle/Settings/coloringAmount", ( int ) coloringAmountSB->value() );

}

//////////////////////////////////////////////////////////////////////////////
// defaults()
// ----------
// Set to the defaults

void Metal4kdeStyleConfig::defaults()
{
#ifdef BACKTRACE
    qWarning( "defaults()" );
#endif

    // misc
    // style settings
    centerTabs->setChecked( FALSE );
    EnableHarderLightningCB->setChecked( FALSE );

    // highlightning stuff
    highlights->setChecked( FALSE );
    enableAnimateCB->setChecked( FALSE );
    enableFullCycleCB->setChecked( FALSE );
    enterAnimateTimingSB->setValue( 5 );
    leaveAnimateTimingSB->setValue( 20 );
    animateTolaranceSB->setValue( 50 );

    // custom colors
    cbUseCustomColors->setChecked( FALSE );
    //others
    coloringAmountSB->setValue( 30 );
}

//////////////////////////////////////////////////////////////////////////////
// Plugin Stuff                                                             //
//////////////////////////////////////////////////////////////////////////////

extern "C"
{
    QObject* allocate_kstyle_config( QWidget * parent )
    {
#ifdef BACKTRACE
        qWarning( "extern C - allocate_kstyle_config()" );
#endif
        return ( new Metal4kdeStyleConfig( parent ) );
    }
}

#include "Metal4kdestyleconfig.moc"
