/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Metal4kde.h"

#include <ktoolbarbutton.h>
#include <qwindowdefs.h>


// bool Metal4kdeStyle::eventFilter( QObject *object, QEvent *event )
// {
// return false;
// }

//////////////////////////////////////////////////////////////////////////////
// eventFilter()
// -------------
// Grab events we are interested in. Most of this routine is to handle the
// exceptions to the normal styling rules.
bool Metal4kdeStyle::eventFilter( QObject *object, QEvent *event )
{
#ifdef BACKTRACE
    qWarning( "eventFilter()" );
#endif


    if ( KStyle::eventFilter( object, event ) )
        return true;
    if ( !object->isWidgetType() )
        return false;

    QWidget *widget;

    switch ( event->type() )
    {
        //     case QEvent::Paint :
        //         {
        //             //qWarning( "Paint events" );
        //
        //             widget = ( QWidget* ) object;
        //             return FALSE;
        //         }

    case QEvent::PaletteChange :
    case QEvent::ApplicationPaletteChange :
        {
            //qWarning( "PaletteChange ApplicationPaletteChange events" );

            widget = ( QWidget* ) object;

            if ( widget->inherits( "QTipLabel" ) )
                widget->setPalette(tooltipPalette_);

            return(true);
        }

    case QEvent::Show :
        {
            //  qWarning( "Show events" );

            widget = ( QWidget* ) object;

            if ( widget->inherits( "KActiveLabel" ) )
            {
                QPalette pal( widget->palette() );
                QSize sz = widget->size();
                QPixmap pix( sz.width(), 100 );
                QPoint pos( 0, 0 );
                pos = widget->mapTo( widget->topLevelWidget(), pos );
                QWidget *topLevelWidget = widget->topLevelWidget();
                QPainter p;
                p.begin( &pix );
                p.drawTiledPixmap( QRect( 0 - pos.x(), 0 - pos.y(), topLevelWidget->width(), topLevelWidget->height() ), *brushedMetalPix_ ) ;
                p.drawPixmap( 0 - pos.x() + ( topLevelWidget->width() / 2 ) - 512 , 0 , *brushedMetalLightningPix_, 0, 0, 1024, 100 );
                if(optionsHandler_->enableHarderLightning_)
                    p.drawPixmap( 0 - pos.x() + ( topLevelWidget->width() / 2 ) - 512 , 0 , *brushedMetalLightningPix_, 0, 0, 1024, 100 );
                p.end();
                QBrush brush( pal.active().background(), pix );
                pal.setBrush( QColorGroup::Base, brush );
                widget->setPalette( pal );
            }
            else if ( widget->inherits( "QDockWindow" ) || widget->inherits( "KToolBarSeparator" ) && !konqueror_ )
            {
                if ( widget->backgroundMode() != Qt::PaletteBackground )
                {
                    // Qt resets the background mode during init. We want to
                    // change if back right away because it does an erase before
                    // painting which would look ugly in the wrong color and toolbar
                    // separators got the wrong palette :P
                    widget->setBackgroundMode( Qt::PaletteBackground );
                    widget->setBackgroundOrigin( QWidget::WindowOrigin );
                }
            }
            else if ( widget->inherits( "QPopupMenu" ) )
            {
                int width = widget->width();
                int height = 100;
                qWarning( "%d", width );
                QPixmap gradiantBrushed( width, height );
                QPainter p;
                p.begin( &gradiantBrushed );
                p.drawTiledPixmap( 0, 0, width, height, *brushedMetalPix_ );
                p.drawPixmap( 0 , 0, *brushedMetalLightningPix_, 200, 0, 1024, 100 );
                p.drawPixmap( 0, 0, *menuLeftPix_ );
                p.drawPixmap( width - 50, 0, *menuRightPix_ );

                //FIXME  change pixmap to 100 * 100
                p.drawPixmap( 0, 50, *menuLeftPix_ );
                p.drawPixmap( width - 50, 50, *menuRightPix_ );

                p.end();

                widget->setPaletteBackgroundPixmap( gradiantBrushed );

            }
            else if ( ( widget->inherits( "QToolButton" ) ||
                        widget->inherits( "KToolBarSeparator" ) ||
                        widget->inherits( "QTabBar" ) ||
                        widget->inherits( "QDockWindow" ) ) &&
                      konqueror_
                    )
            {
                //qWarning( "Show events" );

                widget->setErasePixmap( *( widget->topLevelWidget() ->erasePixmap() ) );

            }
            else if ( ( widget->isTopLevel() ) &&
                      !( widget->isDesktop() || widget->isPopup() || widget->inherits( "QTipLabel" ) )
                    )
            {
                prepareBacckground( widget );
            }

            return FALSE;
        }

    case QEvent::Resize :
        {

            //qWarning( "Resize events" );

            QResizeEvent * re = ( QResizeEvent* ) event;
            widget = ( QWidget* ) object;

            if ( widget->isTopLevel() &&
                    !( widget->isDesktop() || widget->isPopup() || widget->inherits( "QTipLabel" ) ) &&
                    re->oldSize().width() != re->size().width()
               )
            {
                prepareBacckground( widget );
            }

            return FALSE;
        }

    case QEvent::Enter:
        {
            //qWarning( "Enter events" );

            widget = ( QWidget* ) object;

            //showWidgetInformation( widget );

            if ( ::qt_cast<QScrollBar*>( object ) )
            {

                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        hover_ = widget;
                        //widget->repaint( false );
                        scrollBarTimer_ = new QTimer( widget );
                        scrollBarTimer_->start( 100 );
                        connect( scrollBarTimer_, SIGNAL( timeout() ), this, SLOT( updateScrollBar() ) );
                        connect( this, SIGNAL( animate( bool ) ), widget, SLOT( repaint( bool ) ) );
                        //qWarning( "start" );
                    }
                }
            }

            else if ( ::qt_cast<QHeader*>( object ) )
            {

                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        QHeader * header = ( QHeader * ) object;
                        currentHeader_ = header;
                        headerHoverID_ = -1;
                        //qWarning( "enter header" );
                    }
                }
            }
            else if ( ::qt_cast<QComboBox*>( object ) ||
                      ::qt_cast<QPushButton*>( object ) )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( ::qt_cast<QComboBox*>( object ))
                    {
                        QComboBox * combo = ( QComboBox* ) widget;

                        if (combo->editable())
                        {
                            return FALSE;
                        }
                    }

                    if ( optionsHandler_->enableAnimate_ )
                    {
                        char widgetId[ 20 ] = {0};
                        sprintf( widgetId, "%ul", widget->winId() );
                        animationWidget *animWidget;
                        animWidget = animationWidgetDict_.find( widgetId );

                        if ( !animWidget )
                        {
                            //qWarning( "enter - %ul", widget );
                            //qWarning( "%s", widgetAdress );
                            animationWidget *anm = new animationWidget( this, widget , optionsHandler_ );
                            animationWidgetDict_.insert( widgetId, anm );
                        }
                        else
                        {
                            animWidget->animProgress_ = 100 + optionsHandler_->animateTolerance_;
                            animWidget->hover_ = true;
                            animWidget->flag_ = true;
                            animWidget ->startAnimation();
                        }
                    }
                    else if ( optionsHandler_->highlights_ )
                    {
                        hover_ = widget;
                        widget->repaint( false );
                    }

                }
            }
            else if ( ::qt_cast<QSpinWidget*>( object ) ||
                      ::qt_cast<QCheckBox*>( object ) ||
                      ::qt_cast<QRadioButton*>( object ) ||
                      ::qt_cast<QSlider*>( object ) ||
                      ::qt_cast<QTabBar*>( object )
                    )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        hover_ = widget;
                        widget->repaint( false );
                    }
                }
            }
            return FALSE;
        }
    case QEvent::Leave :
        {
            //qWarning( "Leave events" );

            if ( ::qt_cast<QScrollBar*>( object ) )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        hover_ = 0;
                        disconnect( scrollBarTimer_, SIGNAL( timeout() ), this, SLOT( updateScrollBar() ) );
                        disconnect( this, SIGNAL( animate( bool ) ), widget, SLOT( repaint( bool ) ) );
                        scrollBarTimer_->stop();
                        if (scrollBarTimer_)
                            delete scrollBarTimer_;
                        scrollBarStartNum_ = 120;
                        scrollBarAnimShift_ = 5;
                        scrollBarMovementmShift_ = 0;
                        //qWarning( "end" );
                        widget->repaint( false );
                    }

                }
            }

            else if ( ::qt_cast<QHeader*>( object ) )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        //qWarning( "leave header");
                        //QHeader * header = ( QHeader * ) object;
                        currentHeader_ = 0;
                        headerHoverID_ = -1;
                        widget->repaint( false );
                    }
                }
            }
            else if ( ::qt_cast<QComboBox*>( object ) ||
                      ::qt_cast<QPushButton*>( object )
                    )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->enableAnimate_ )
                    {
                        char widgetId[ 20 ] = {0};
                        sprintf( widgetId, "%ul", widget->winId() );
                        animationWidget *animWidget;
                        animWidget = animationWidgetDict_.find( widgetId );

                        if ( animWidget )
                        {
                            animWidget->flag_ = false;
                            if(animWidget->animTimer_)
                                animWidget ->startAnimation();
                            else
                                qWarning( "found" );
                        }
                    }
                    else if ( optionsHandler_->highlights_ )
                    {
                        hover_ = 0;
                        widget->repaint( false );
                    }
                }
            }
            else if ( ::qt_cast<QSpinWidget*>( object ) ||
                      ::qt_cast<QCheckBox*>( object ) ||
                      ::qt_cast<QRadioButton*>( object ) ||
                      ::qt_cast<QHeader*>( object ) ||
                      ::qt_cast<QSlider*>( object ) ||
                      ::qt_cast<QTabBar*>( object )
                    )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        hover_ = 0;
                        widget->repaint( false );
                    }
                }
            }
            return FALSE;
        }

    case QEvent::MouseMove :
        {
            //qWarning( "MouseMove events" );

            if ( ::qt_cast<QHeader*>( object ) )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        QHeader * header = ( QHeader * ) object;
                        QMouseEvent * me = ( QMouseEvent * ) event;
                        int oldHeader = headerHoverID_;
                        headerHoverID_ = header->sectionAt( me->x() + header->offset() );
                        //                 qWarning( "oldHeader - %d", oldHeader );
                        //                 qWarning( "headerHoverID_ - %d", headerHoverID_ );
                        //                 qWarning( "offset - %d\n", header->offset() );
                        if ( oldHeader != headerHoverID_ )
                        {
                            //qWarning( "painting" );
                            // paint the old one
                            if ( oldHeader != -1 )
                            {
                                //qWarning( "oldHeader sectionPos - %d", header->sectionPos( oldHeader ) );
                                header->repaint( header->sectionPos( oldHeader ) - header->offset(), 0,
                                                 header->sectionSize( oldHeader ), header->height() );
                            }
                            // paint the new one
                            if ( headerHoverID_ != -1 )
                            {
                                //qWarning( "headerHoverID_ sectionPos - %d", header->sectionPos( headerHoverID_ ) );
                                header->repaint( header->sectionPos( headerHoverID_ ) - header->offset(), 0,
                                                 header->sectionSize( headerHoverID_ ), header->height() );
                            }
                        }
                    }
                }
            }

            if (  ::qt_cast<QTabBar*>( object )
               )
            {
                if ( ( widget = dynamic_cast<QWidget*>( object ) ) &&
                        widget->
                        isEnabled() )
                {
                    if ( optionsHandler_->highlights_ )
                    {
                        widget->repaint( false );
                    }
                }
            }
            return FALSE;
        }

    default: return false;
    }

    return FALSE;
}


void Metal4kdeStyle::prepareBacckground( QWidget *widget )
{
#ifdef BACKTRACE
    qWarning( "prepareBacckground()" );
#endif
    QWidget * topLevelWidget = widget;
    bool loop = TRUE;

    while ( topLevelWidget->parentWidget() && loop )
    {
        if ( topLevelWidget->isDialog() )
            loop = FALSE;
        else
            topLevelWidget = topLevelWidget->parentWidget();
    }

    int width = topLevelWidget->width();
    QPalette pal = topLevelWidget->palette();
    QPixmap gradiantBrushed( width, 100 );

    QPainter p;
    p.begin( &gradiantBrushed );
    p.drawTiledPixmap( 0, 0, width, 100, *brushedMetalPix_ );
    p.drawPixmap( ( width / 2 ) - 512 , 0, *brushedMetalLightningPix_, 0, 0, 1024, 100 );
    if(optionsHandler_->enableHarderLightning_)
        p.drawPixmap( ( width / 2 ) - 512 , 0, *brushedMetalLightningPix_, 0, 0, 1024, 100 );
    p.end();

    QColor c( pal.active().background() );
    QBrush brush( c, gradiantBrushed );
    pal.setBrush( QColorGroup::Background, brush );
    //qApp->setPalette( pal );
    if ( konqueror_ )
    {
        topLevelWidget->setErasePixmap( gradiantBrushed );
    }
    else
    {
        //qApp->setPalette( pal );
        topLevelWidget->setPalette( pal );
    }


    QObjectList *childrens = topLevelWidget->queryList( "QWidget" );
    for ( int i = 0; i < childrens->count(); i++ )
    {
        QWidget *child = ( QWidget* ) childrens->at( i );

        //  qWarning( child->className() );

        if ( child )
        {
            if ( !qstrcmp( child->name(), "kde toolbar widget" ) || child->inherits( "QToolBarExtensionWidget" ) )
            {
                pal = QPalette( child->palette() );
                {
                    pal.setBrush( QColorGroup::Button, brush );
                    pal.setBrush( QColorGroup::Background, brush );
                    child->setPalette( pal );
                }

                //                         child->setErasePixmap( gradiantBrushed );
            }
            else if ( child->inherits( "QPushButton" ) ||
                      child->inherits( "QComboBox" ) )
            {
                pal = QPalette( child->palette() );
                {
                    pal.setBrush( QColorGroup::Background, brush );
                    child->setPalette( pal );
                }
            }
            else if ( konqueror_ )
            {

                if ( child->backgroundOrigin() == QWidget::WindowOrigin )
                    child->setErasePixmap( gradiantBrushed );


            }
        }
    }

}

void Metal4kdeStyle::showWidgetInformation( QWidget *widget )
{
#ifdef BACKTRACE
    qWarning( "showWidgetInformation()" );
#endif

    qWarning( "Enter events" );
    qWarning( "class name - %s", widget->className() );
    qWarning( "name - %s", widget->name() );

    // qt
    if ( widget->inherits( "QAxWidget" ) )
        qWarning( "inherits QAxWidget" );
    if ( widget->inherits( "QButton" ) )
        qWarning( "inherits QButton" );
    if ( widget->inherits( "QFrame" ) )
        qWarning( "inherits QFrame" );
    if ( widget->inherits( "QDialog" ) )
        qWarning( "inherits QDialog" );
    if ( widget->inherits( "QComboBox" ) )
        qWarning( "inherits QComboBox" );
    if ( widget->inherits( "QDataBrowser" ) )
        qWarning( "inherits QDataBrowser" );
    if ( widget->inherits( "QDataView" ) )
        qWarning( "inherits QDataView" );
    if ( widget->inherits( "QDateTimeEditBase" ) )
        qWarning( "inherits QDateTimeEditBase" );
    if ( widget->inherits( "QDateTimeEdit" ) )
        qWarning( "inherits QDateTimeEdit" );
    if ( widget->inherits( "QDesktopWidget" ) )
        qWarning( "inherits QDesktopWidget" );
    if ( widget->inherits( "QDial" ) )
        qWarning( "inherits QDial" );
    if ( widget->inherits( "QDockArea" ) )
        qWarning( "inherits QDockArea" );
    if ( widget->inherits( "QGLWidget" ) )
        qWarning( "inherits QGLWidget" );
    if ( widget->inherits( "QHeader" ) )
        qWarning( "inherits QHeader" );
    if ( widget->inherits( "QMainWindow" ) )
        qWarning( "inherits QMainWindow" );
    if ( widget->inherits( "QMotifWidget" ) )
        qWarning( "inherits QMotifWidget" );
    if ( widget->inherits( "QNPWidget" ) )
        qWarning( "inherits QNPWidget" );
    if ( widget->inherits( "QScrollBar" ) )
        qWarning( "inherits QScrollBar" );
    if ( widget->inherits( "QSizeGrip" ) )
        qWarning( "inherits QSizeGrip" );
    if ( widget->inherits( "QSlider" ) )
        qWarning( "inherits QSlider" );
    if ( widget->inherits( "QSpinBox" ) )
        qWarning( "inherits QSpinBox" );
    if ( widget->inherits( "QSplashScreen" ) )
        qWarning( "inherits QSplashScreen" );
    if ( widget->inherits( "QStatusBar" ) )
        qWarning( "inherits QStatusBar" );
    if ( widget->inherits( "QTabBar" ) )
        qWarning( "inherits QTabBar" );
    if ( widget->inherits( "QTabWidget" ) )
        qWarning( "inherits QTabWidget" );
    if ( widget->inherits( "QWorkspace" ) )
        qWarning( "inherits QWorkspace" );
    if ( widget->inherits( "QXtWidget" ) )
        qWarning( "inherits QXtWidget" );
    if ( widget->inherits( "QWidget" ) )
        qWarning( "inherits QWidget" );

    // kde
    if ( widget->inherits( "KCModule" ) )
        qWarning( "inherits KCModule" );
    if ( widget->inherits( "KFontCombo" ) )
        qWarning( "inherits KFontCombo" );

    qWarning( "width = %d, height = %d", widget->width(), widget->height() );

    qWarning( "-------------------------" );
}




