/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Metal4kde.h"

//////////////////////////////////////////////////////////////////////////////
// optionsHandler()
// -----------
// Constructor
optionsHandler::optionsHandler( QObject *parent ) : QObject( parent )
{
#ifdef BACKTRACE
    qWarning( "optionsHandler()" );
#endif

    reloadSettings();
}

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// Destractor
optionsHandler::~optionsHandler()
{
#ifdef BACKTRACE
    qWarning( "~optionsHandler()" );
#endif

    ;
}

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// Constructor
void optionsHandler::reloadSettings()
{
#ifdef BACKTRACE
    qWarning( "reloadSettings()" );
#endif

    QSettings settings;

    // misc
    // style settings
    centerTabs_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/centerTabs", FALSE );
    enableHarderLightning_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/EnableHarderLightning", FALSE );

    // highlight stuff
    highlights_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/highlights", FALSE );
    enableAnimate_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/enableAnimate", FALSE );
    enableFullcycle_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/enableFullCycle", FALSE );
    enterAnimateTiming_ = settings.readNumEntry( "/Metal4kdestyle/Settings/enterAnimateTiming", 5 );
    leaveAnimateTiming_ = settings.readNumEntry( "/Metal4kdestyle/Settings/leaveAnimateTiming", 20 );
    animateTolerance_ = settings.readNumEntry( "/Metal4kdestyle/Settings/animateTolarance", 50 );

    // custom colors
    useCustomColors_ = settings.readBoolEntry( "/Metal4kdestyle/Settings/useCustomColors", FALSE );

    QColor bgColor = qApp->palette().active().background();

    // widgets
    if ( useCustomColors_ )
    {
        customColors_[ CustomTabOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/tabOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomTabOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/tabOnColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomRadioOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/radioOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomRadioOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/radioOnColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomCBOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/chackBoxOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomCBOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/chackBoxOnColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomScrollBarSliderOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/scrollBarSliderOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomScrollBarSliderOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/scrollBarSliderOnColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomSliderHandleOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/sliderHandleOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomSliderHandleOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/sliderHandleOnColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomButtonOff ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/buttonOffColor", ( int ) bgColor.rgb() ) );
        customColors_[ CustomButtonOn ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/buttonOnColor", ( int ) bgColor.rgb() ) );
    }
    else
    {
        QColorGroup group = qApp->palette().active();

        customColors_[ CustomTabOff ] = group.background();
        customColors_[ CustomTabOn ] = group.button();
        customColors_[ CustomRadioOff ] = group.background();
        customColors_[ CustomRadioOn ] = group.button();
        customColors_[ CustomCBOff ] = group.background();
        customColors_[ CustomCBOn ] = group.button();
        customColors_[ CustomScrollBarSliderOff ] = group.background();
        customColors_[ CustomScrollBarSliderOn ] = group.button();
        customColors_[ CustomSliderHandleOff ] = group.background();
        customColors_[ CustomSliderHandleOn ] = group.button();
        customColors_[ CustomButtonOff ] = group.background();
        customColors_[ CustomButtonOn ] = group.button();
    }

    // other widgets
    customColors_[ CustomWidgetBorderColor ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/WidgetsBorderColor", ( int ) bgColor.rgb() ) );

    customColors_[ CustomBrushedMetal ].setRgb( settings.readNumEntry( "/Metal4kdestyle/Settings/BrushedMetalColor", ( int ) bgColor.rgb() ) );
    // others
    coloringAmount_ = settings.readNumEntry( "/Metal4kdestyle/Settings/coloringAmount", 30 );

}














