/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Metal4kde.h"
#include <qmetaobject.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <qfile.h>
#include <qdir.h>


//////////////////////////////////////////////////////////////////////////////
// Polishing                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// polish()
// --------
// Initialize application specific
void Metal4kdeStyle::polish( QApplication* app )
{
#ifdef BACKTRACE
    qWarning( "polish( QApplication* app )" );
#endif

    if ( !qstrcmp( app->argv() [ 0 ], "kicker" ) )
        kicker_ = TRUE;

    if ( !qstrcmp( app->argv() [ 0 ], "konqueror" ) )
        konqueror_ = TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// polish()
// --------
// Initialize the palette

// void Metal4kdeStyle::polish( QPalette &pal )
// {
// #ifdef BACKTRACE
//     qWarning( "polish( QPalette &pal )" );
// #endif
//
//     // clear out all old colorized pixmaps_
//     for ( int i = 0; i < BitmapDataCount; ++i )
//     {
//         if ( pixmaps_[ i ] )
//         {
//             delete pixmaps_[ i ];
//             pixmaps_[ i ] = NULL;
//         }
//     }
//
//     // clear out all dicts
//     btnDict_.clear();
//     clearFillSmallDict_.clear();
//     clearFillLargeDict_.clear();
//     verScrollBarTopDict_.clear();
//     verScrollBarMidDict_.clear();
//     verScrollBarBtmDict_.clear();
//     horScrollBarTopDict_.clear();
//     horScrollBarMidDict_.clear();
//     horScrollBarBtmDict_.clear();
//
//     //animationWidgetDict_.clear();
//
//     // set background for all widgets
//     bool newPalette = false;
//     struct stat buffer;
//     if(stat(QFile::encodeName(QDir::homeDirPath()+"/.qt/qtrc"), &buffer) == 0)
//     {
//         unsigned int lastModTime = (unsigned int)buffer.st_mtime;
//         if(lastModTime > qtrcModificationTime_)
//         {
//             qtrcModificationTime_ = lastModTime;
//             newPalette = true;
//         }
//     }
//     else if(!initialPaletteLoaded_) // Hack, should always have qtrc in KDE
//         newPalette = true;
//     initialPaletteLoaded_ = true;
//
//     if(!newPalette)
//     {
//         pal = polishedPalette_;
//         return;
//     }
//
//     QColor c( pal.active().background() );
//     QBrush brush( c, *brushedMetalPix_ );
//     //QBrush brush( Qt::gray );
//     pal.setBrush( QColorGroup::Background, brush );
//
//     polishedPalette_ = pal;
//
//     QStyle::polish( pal );
// }


void Metal4kdeStyle::polish( QPalette &pal )
{
#ifdef BACKTRACE
    qWarning( "polish( QPalette &pal )" );
#endif

    //     qWarning( "polish( QPalette &pal ) called" );

    // clear out all old colorized pixmaps_
    for ( int i = 0; i < BitmapDataCount; ++i )
    {
        if ( pixmaps_[ i ] )
        {
            delete pixmaps_[ i ];
            pixmaps_[ i ] = NULL;
        }
    }

    // clear out all dicts
    btnDict_.clear();
    btnWebDict_.clear();
    clearFillSmallDict_.clear();
    clearFillLargeDict_.clear();
    verScrollBarTopDict_.clear();
    verScrollBarMidDict_.clear();
    verScrollBarBtmDict_.clear();
    horScrollBarTopDict_.clear();
    horScrollBarMidDict_.clear();
    horScrollBarBtmDict_.clear();
    //animationWidgetDict_.clear();

    // set background for all widgets
    QColor c( pal.active().background() );
    QBrush brush( c, *brushedMetalPix_ );
    //QBrush brush( Qt::gray );
    pal.setBrush( QColorGroup::Background, brush );

    QStyle::polish( pal );
}



//////////////////////////////////////////////////////////////////////////////
// polish()
// --------
// Initialize the widget
void Metal4kdeStyle::polish( QWidget *widget )
{
#ifdef BACKTRACE
    qWarning( "polish( QWidget *widget )" );
#endif

    // qWarning(widget->className());
    // qWarning("%ul",&widget);
    if ( !qstrcmp( widget->name(), "kde toolbar widget" ) || widget->inherits( "QToolBarExtensionWidget" ) )
    {
        // can't just set the background mode to background because the widget
        // resets it to button :P
        QPalette pal( widget->palette() );
        pal.setBrush( QColorGroup::Button, qApp->palette().active().brush( QColorGroup::Background ) );
        widget->setPalette( pal );
        if ( !kicker_ )
            widget->setBackgroundOrigin( QWidget::WindowOrigin );
    }
    else if ( widget->inherits( "KHTMLView" ) || widget->inherits( "KonqIconViewWidget" ) )
    {
        //reset pixmap, since Konq animation can't handle it
        QPalette pal( widget->palette() );
        pal.setBrush( QColorGroup::Background, pal.active().background() );
        widget->setPalette( pal );
        //             widget->setBackgroundMode( QWidget::PaletteBackground );
        //             widget->setPaletteBackgroundColor( widget->palette().active().background() );
    }
    else if ( widget->inherits( "QLineEdit" ) )
    {
        QPalette pal( widget->palette() );
        pal.setBrush( QColorGroup::Background, pal.active().background() );
        widget->setPalette( pal );

        //             widget->setPaletteBackgroundColor( widget->palette().active().background() );
    }
    else if(widget->inherits("QTipLabel"))
    {
        widget->setPalette(tooltipPalette_);
        widget->installEventFilter(this);
        return;
    }
    else if ( widget->inherits( "KActiveLabel" ) )
    {
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QCheckBox" ) )
    {
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QRadioButton" ) )
    {

        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QPushButton" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QToolButton" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QComboBox" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QMenuBar" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
    }
    else if ( widget->inherits( "QProgressBar" ) )
    {
        widget->setBackgroundMode( NoBackground );
        //         QTimer* timer = new QTimer( widget );
        //         timer->start( 50 );
        //         connect( timer, SIGNAL( timeout() ), widget, SLOT( update() ) );
        progAnimShift_ = 46;

        char widgetId[ 20 ] = {0};
        sprintf( widgetId, "%ul", widget->winId() );
        animationWidget *animWidget;
        animWidget = animationWidgetDict_.find( widgetId );

        if ( !animWidget )
        {
            //qWarning( "enter - %ul", widget->winId() );
            //qWarning( "%s", widgetId );

            animationWidget *anm = new animationWidget( this, widget , optionsHandler_ );
            animationWidgetDict_.insert( widgetId, anm );
        }
    }
    else if ( widget->inherits( "QHeader" ) )
    {
        widget->setBackgroundMode( NoBackground );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QSpinWidget" ) )
    {
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QDockWindow" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QPopupMenu" ) )
    {
        widget->setBackgroundMode( QWidget::PaletteBackground );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QTabBar" ) )
    {
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->setMouseTracking( true );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "KToolBarSeparator" ) )
    {
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QScrollBar" ) )
    {
        widget->setBackgroundMode( NoBackground );
        widget->installEventFilter( this );
    }
    else if ( widget->inherits( "QScrollView" ) && !kicker_ )
    {
        widget->setBackgroundOrigin( QWidget::WindowOrigin );
        widget->setMouseTracking( true );
        //widget->installEventFilter( this );
    }
    else if ( ! kicker_ && !kdesktop_ )
    {
        if ( widget->backgroundMode() == QWidget::PaletteBackground ||
                widget->backgroundMode() == QWidget::PaletteButton )
        {
            widget->setBackgroundOrigin( QWidget::WindowOrigin );
        }
    }

    if ( widget->isTopLevel() && ! widget->inherits("QToolTip") )
    {
        widget->installEventFilter( this );
    }

    KStyle::polish( widget );
}

//////////////////////////////////////////////////////////////////////////////
// unPolish()
// ----------
// Undo the initialization of a widget's appearance
void Metal4kdeStyle::unPolish( QWidget * widget )
{
#ifdef BACKTRACE
    qWarning( "unPolish()" );
#endif

    widget->removeEventFilter(this);

    if ( !qstrcmp( widget->name(), "kde toolbar widget" ) || widget->inherits( "QToolBarExtensionWidget" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "KHTMLView" ) || widget->inherits( "KonqIconViewWidget" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QLineEdit" ) )
    {
        widget->unsetPalette();
        widget->setBackgroundOrigin( QWidget::WidgetOrigin );
    }
    else if ( widget->inherits( "KActiveLabel" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QCheckBox" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QRadioButton" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }

    }
    else if ( widget->inherits( "QPushButton" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }

    }
    else if ( widget->inherits( "QToolButton" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
            widget->setBackgroundMode(QWidget::PaletteButton);
        }
    }
    else if ( widget->inherits( "QComboBox" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QMenuBar" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    if ( widget->inherits( "QProgressBar" ) )
    {
        progAnimShift_ = 46;

        char widgetId[ 20 ] = {0};
        sprintf( widgetId, "%ul", widget->winId() );
        animationWidget *animWidget;
        animWidget = animationWidgetDict_.find( widgetId );
        if ( animWidget )
            animWidget->animTimer_->stop();
        widget->unsetPalette();
        widget->setBackgroundOrigin( QWidget::WidgetOrigin );
    }
    else if ( widget->inherits( "QHeader" ) )
    {
        widget->unsetPalette();
        widget->setBackgroundOrigin( QWidget::WidgetOrigin );
    }
    else if ( widget->inherits( "QSpinWidget" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QDockWindow" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QPopupMenu" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundMode( QWidget::PaletteButton );
        }
    }
    else if ( widget->inherits( "QTabBar" ) )
    {
        if(widget->ownPalette())
        {
            widget->setMouseTracking( FALSE );
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "KToolBarSeparator" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QScrollBar" ) )
    {
        if(widget->ownPalette())
        {
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( widget->inherits( "QScrollView" ) && !kicker_ )
    {
        if(widget->ownPalette())
        {
            widget->setMouseTracking( false );
            widget->unsetPalette();
            widget->setBackgroundOrigin( QWidget::WidgetOrigin );
        }
    }
    else if ( ! kicker_ /*&& !kdesktop_*/ )
    {
        if(widget->ownPalette())
        {
            if ( widget->backgroundMode() == QWidget::PaletteBackground ||
                    widget->backgroundMode() == QWidget::PaletteButton )
            {
                widget->setBackgroundOrigin( QWidget::WidgetOrigin );
            }
        }
    }

    if ( widget->isTopLevel() && ! widget->inherits("QToolTip") )
    {
        widget->removeEventFilter( this );
    }


    KStyle::unPolish( widget );
}



