/***************************************************************************
 *   Copyright (C) 2004 by moty rahamim                                    *
 *   moty@onexige.com                                                      *
 *                                                                         *
 *   just another metalic like Kstyle & Kwin, this theme is based on:      *
 *   Phase & example by David Johnson                                      *
 *   liquid by Daniel M. Duley a.k.a Mosfet <mosfet@idunno>                *
 *   baghira by Thomas Lbking <thomas.luebking@web.de>                    * 
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Metal4kde.h"

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// separateTiles

ButtonTile* Metal4kdeStyle::separateTiles( QPixmap *pix, int leftCornerTileWidth, int midTilesWidth, int rightCornerTileWidth, int upCornerTileHeight, int midTilesHeight, int downCornerTileHeight ) const
{
#ifdef BACKTRACE
    qWarning( "separateTiles()" );
#endif

    ButtonTile * tile = new ButtonTile();
    QPixmap *tmp;
    QBitmap *tmpMask;

    // Top tiles
    // left
    tmp = new QPixmap( leftCornerTileWidth, upCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, 0, 0, leftCornerTileWidth, upCornerTileHeight );
    tile->setPixmap( TileTopLeft, tmp );
    // mid
    tmp = new QPixmap( midTilesWidth, upCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, leftCornerTileWidth, 0, midTilesWidth, upCornerTileHeight );
    tile->setPixmap( TileTop, tmp );
    // right
    tmp = new QPixmap( rightCornerTileWidth, upCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, leftCornerTileWidth + midTilesWidth, 0, rightCornerTileWidth, upCornerTileHeight );
    tile->setPixmap( TileTopRight, tmp );

    // Middle tiles
    // left
    tmp = new QPixmap( leftCornerTileWidth, midTilesHeight );
    bitBlt( tmp, 0, 0, pix, 0, upCornerTileHeight, leftCornerTileWidth, midTilesHeight );
    tile->setPixmap( TileLeft, tmp );
    // mid
    tmp = new QPixmap( midTilesWidth, midTilesHeight );
    bitBlt( tmp, 0, 0, pix, leftCornerTileWidth, upCornerTileHeight, midTilesWidth, midTilesHeight );
    tile->setPixmap( TileMiddle, tmp );
    // right
    tmp = new QPixmap( rightCornerTileWidth, midTilesHeight );
    bitBlt( tmp, 0, 0, pix, leftCornerTileWidth + midTilesWidth, upCornerTileHeight, rightCornerTileWidth, midTilesHeight );
    tile->setPixmap( TileRight, tmp );

    // Bottom tiles
    // left
    tmp = new QPixmap( leftCornerTileWidth, downCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, 0, upCornerTileHeight + midTilesHeight, leftCornerTileWidth, downCornerTileHeight );
    tile->setPixmap( TileBtmLeft, tmp );
    // mid
    tmp = new QPixmap( midTilesWidth, downCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, leftCornerTileWidth, upCornerTileHeight + midTilesHeight, midTilesWidth, downCornerTileHeight );
    tile->setPixmap( TileBtm, tmp );
    // right
    tmp = new QPixmap( rightCornerTileWidth, downCornerTileHeight );
    bitBlt( tmp, 0, 0, pix, rightCornerTileWidth + midTilesWidth, upCornerTileHeight + midTilesHeight, rightCornerTileWidth, downCornerTileHeight );
    tile->setPixmap( TileBtmRight, tmp );


    // masks
    // top
    // left
    tmpMask = new QBitmap( leftCornerTileWidth, upCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), 0, 0, leftCornerTileWidth, upCornerTileHeight );
    tile->pixmap( TileTopLeft ) ->setMask( *tmpMask );
    delete tmpMask;
    // mid
    tmpMask = new QBitmap( midTilesWidth, upCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), leftCornerTileWidth, 0, midTilesWidth, upCornerTileHeight );
    tile->pixmap( TileTop ) ->setMask( *tmpMask );
    delete tmpMask;
    // right
    tmpMask = new QBitmap( rightCornerTileWidth, upCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), leftCornerTileWidth + midTilesWidth, 0, rightCornerTileWidth, upCornerTileHeight );
    tile->pixmap( TileTopRight ) ->setMask( *tmpMask );
    delete tmpMask;

    // mid
    // left
    tmpMask = new QBitmap( leftCornerTileWidth, midTilesHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), 0, upCornerTileHeight, leftCornerTileWidth, midTilesHeight );
    tile->pixmap( TileLeft ) ->setMask( *tmpMask );
    delete tmpMask;
    // mid
    tmpMask = new QBitmap( midTilesWidth, midTilesHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), leftCornerTileWidth, upCornerTileHeight, midTilesWidth, midTilesHeight );
    tile->pixmap( TileMiddle ) ->setMask( *tmpMask );
    delete tmpMask;
    // right
    tmpMask = new QBitmap( rightCornerTileWidth, midTilesHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), leftCornerTileWidth + midTilesWidth, upCornerTileHeight, rightCornerTileWidth, midTilesHeight );
    tile->pixmap( TileRight ) ->setMask( *tmpMask );
    delete tmpMask;

    // buttom
    // left
    tmpMask = new QBitmap( leftCornerTileWidth, downCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), 0, upCornerTileHeight + midTilesHeight, leftCornerTileWidth, downCornerTileHeight );
    tile->pixmap( TileBtmLeft ) ->setMask( *tmpMask );
    delete tmpMask;
    // mid
    tmpMask = new QBitmap( midTilesWidth, downCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), leftCornerTileWidth, upCornerTileHeight + midTilesHeight, midTilesWidth, downCornerTileHeight );
    tile->pixmap( TileBtm ) ->setMask( *tmpMask );
    delete tmpMask;
    // right
    tmpMask = new QBitmap( rightCornerTileWidth, downCornerTileHeight );
    bitBlt( tmpMask, 0, 0, pix->mask(), rightCornerTileWidth + midTilesWidth, upCornerTileHeight + midTilesHeight, rightCornerTileWidth, downCornerTileHeight );
    tile->pixmap( TileBtmRight ) ->setMask( *tmpMask );
    delete tmpMask;

    return ( tile );
}

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// drawMetalButton

void Metal4kdeStyle::drawMetalButton( QPainter *painter,
                                      int x, int y, int w, int h,
                                      const QColorGroup &group,
                                      const QColor &fill,
                                      bool isHTMLButton_,
                                      bool sunken, int bgX, int bgY ) const
{
#ifdef BACKTRACE
    qWarning( "drawMetalButton()" );
#endif

    int leftCornerTileWidth = 17, midTilesWidth = 6, rightCornerTileWidth = 17, upCornerTileHeight = 12, midTilesHeight = 2, downCornerTileHeight = 12;
    QColor fillColor = fill;
    Metal4kdeStyle * ptr = const_cast<Metal4kdeStyle*>( this );

    if ( ( w < 26 || h < 22 ) )
    {
        drawClearBevel( painter, x, y, w, h, fill );
        return ;
    }

    ButtonTile *tile = isHTMLButton_ ? btnWebDict_.find( fillColor.rgb() ) : btnDict_.find( fillColor.rgb() );

    if ( !tile )
    {
        QPixmap * buttonPix = new QPixmap();
        buttonPix = adjustHSV( isHTMLButton_ ? *buttonWebImg_ : *buttonImg_, fillColor );
        tile = separateTiles( buttonPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
        if ( tile )
        {
            if(isHTMLButton_)
                ptr->btnWebDict_.insert( fillColor.rgb(), tile );
            else
                ptr->btnDict_.insert( fillColor.rgb(), tile );
        }
    }
    if ( !tile )
    {
        //qWarning( "Button tile is NULL!" );
        return ;
    }

    QPixmap *tmpBtnPix = new QPixmap( w, h );


    QPainter p;
    p.begin( tmpBtnPix );

    if ( isHTMLButton_ )
        p.fillRect( x, y, w, h, Qt::white );
    else
    {

        QPixmap *brushed = group.brush( QColorGroup::Background ).pixmap();
        brushed ? p.drawTiledPixmap( 0, 0, w, h, *brushed, bgX, bgY ) : p.fillRect( 0, 0, w, h, group.brush( QColorGroup::Background ) );
    }

    drawSeperetedTiles( &p, tile, leftCornerTileWidth, rightCornerTileWidth, upCornerTileHeight, downCornerTileHeight, w, h );

    p.end();
    painter->drawPixmap( x, y, *tmpBtnPix, 0, 0, w, h );

    delete tmpBtnPix;
}

//////////////////////////////////////////////////////////////////////////////
// Metal4kdeStyle()
// -----------
// drawMetalCombo


void Metal4kdeStyle::drawMetalCombo(const QComboBox * combo, QPainter *painter,bool mouseHover, SCFlags controls, const QRect &rect,const QColor &fill,bool isHTMLButton_, const QColorGroup &group, int x, int y, SFlags flags, SCFlags active ) const
{
#ifdef BACKTRACE
    qWarning( "drawMetalCombo()" );
#endif

    Metal4kdeStyle *ptr = const_cast<Metal4kdeStyle*>( this );
    int leftCornerTileWidth = 17, midTilesWidth = 6, rightCornerTileWidth = 17, upCornerTileHeight = 12, midTilesHeight = 2, downCornerTileHeight = 12;
    bool hover = mouseHover;
    bool isEditableCombo = combo->editable() ;
    int w = rect.width();
    int h = rect.height();
    QColor c = fill;
    ButtonTile *tile;
    QPen oldPen( painter->pen() );


    QPixmap *tmpBtnPix = new QPixmap( w, h );
    QPainter p;
    p.begin( tmpBtnPix );

    if ( isHTMLButton_ )
        p.fillRect( x, y, w, h, Qt::white );
    else
    {

        QPixmap *brushed = group.brush( QColorGroup::Background ).pixmap();
        brushed ? p.drawTiledPixmap( 0, 0, w, h, *brushed, btnOffset_.x(), btnOffset_.y() ) : p.fillRect( 0, 0, w, h, group.brush( QColorGroup::Background ) );
    }

    if(isEditableCombo)
    {
        QPixmap * comboBoxPix = new QPixmap();
        comboBoxPix = adjustHSV( *editBoxImg_, Qt::white );
        ButtonTile *tile = separateTiles( comboBoxPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
        drawSeperetedTiles( &p, tile, leftCornerTileWidth, rightCornerTileWidth, upCornerTileHeight, downCornerTileHeight, w, h );
    }
    else
    {
        tile = isHTMLButton_ ? btnWebDict_.find( c.rgb() ) : btnDict_.find( c.rgb() );


        if ( !tile )
        {
            QPixmap * comboBoxPix = new QPixmap();
            comboBoxPix = adjustHSV( isHTMLButton_ ? *buttonWebImg_ : *buttonImg_, c );
            tile = separateTiles( comboBoxPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
            if ( tile )
            {
                if(isHTMLButton_)
                    ptr->btnWebDict_.insert( c.rgb(), tile );
                else
                    ptr->btnDict_.insert( c.rgb(), tile );
            }
        }
        if ( !tile )
        {
            //qWarning( "Combo Button tile is NULL!" );
            return ;
        }

        if ( hover )
        {
            p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, 0, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileTop ) );


            p.drawTiledPixmap( 0, upCornerTileHeight, leftCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, upCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileMiddle ) );


            p.drawPixmap( 0, h - downCornerTileHeight, *tile->pixmap( TileBtmLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, h - downCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileBtm ) );

            if(optionsHandler_->enableAnimate_)
            {
                QColor buttonColor;
                buttonColor = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOn ] : group.button();

                ButtonTile *tile = isHTMLButton_ ? btnWebDict_.find( buttonColor.rgb() ) : btnDict_.find( buttonColor.rgb() );

                if ( !tile )
                {
                    QPixmap * comboBoxPix = new QPixmap();
                    comboBoxPix = adjustHSV( isHTMLButton_ ? *buttonWebImg_ : *buttonImg_, buttonColor );
                    tile = separateTiles( comboBoxPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
                    if ( tile )
                    {
                        if(isHTMLButton_)
                            ptr->btnWebDict_.insert( buttonColor.rgb(), tile );
                        else
                            ptr->btnDict_.insert( buttonColor.rgb(), tile );
                    }
                }
                if ( !tile )
                {
                    //qWarning( "Combo Button tile is NULL!" );
                    return ;
                }

                p.drawTiledPixmap( w -21, 0, 9, upCornerTileHeight, *tile->pixmap( TileTop ) );
                p.drawTiledPixmap( w - 21, upCornerTileHeight, 9, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileMiddle ) );
                p.drawTiledPixmap( w - 21, h - downCornerTileHeight, 9, downCornerTileHeight, *tile->pixmap( TileBtm ) );

                p.drawPixmap( w - rightCornerTileWidth, 0, *tile->pixmap( TileTopRight ) );
                p.drawTiledPixmap( w - rightCornerTileWidth, upCornerTileHeight, rightCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileRight ) );
                p.drawPixmap( w - rightCornerTileWidth, h - downCornerTileHeight, *tile->pixmap( TileBtmRight ) );
            }
            else
            {

                p.drawPixmap( w - rightCornerTileWidth, 0, *tile->pixmap( TileTopRight ) );
                p.drawTiledPixmap( w - rightCornerTileWidth, upCornerTileHeight, rightCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileRight ) );
                p.drawPixmap( w - rightCornerTileWidth, h - downCornerTileHeight, *tile->pixmap( TileBtmRight ) );
            }


        }
        else
        {
            p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, 0, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileTop ) );

            p.drawTiledPixmap( 0, upCornerTileHeight, leftCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, upCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileMiddle ) );

            p.drawPixmap( 0, h - downCornerTileHeight, *tile->pixmap( TileBtmLeft ) );
            p.drawTiledPixmap( leftCornerTileWidth, h - downCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileBtm ) );


            QColor buttonColor;
            buttonColor = optionsHandler_->useCustomColors_ ? optionsHandler_->customColors_[ CustomButtonOn ] : group.button();
            ButtonTile *tile = isHTMLButton_ ? btnWebDict_.find( buttonColor.rgb() ) : btnDict_.find( buttonColor.rgb() );

            if ( !tile )
            {
                QPixmap * comboBoxPix = new QPixmap();
                comboBoxPix = adjustHSV(isHTMLButton_ ? *buttonWebImg_ : *buttonImg_, buttonColor);
                tile = separateTiles( comboBoxPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
                if ( tile )
                {
                    if(isHTMLButton_)
                        ptr->btnWebDict_.insert( buttonColor.rgb(), tile );
                    else
                        ptr->btnDict_.insert( buttonColor.rgb(), tile );
                }
            }
            if ( !tile )
            {
                //qWarning( "Combo Button tile is NULL!" );
                return ;
            }

            p.drawTiledPixmap( w -21, 0, 9, upCornerTileHeight, *tile->pixmap( TileTop ) );
            p.drawTiledPixmap( w - 21, upCornerTileHeight, 9, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileMiddle ) );
            p.drawTiledPixmap( w - 21, h - downCornerTileHeight, 9, downCornerTileHeight, *tile->pixmap( TileBtm ) );

            p.drawPixmap( w - rightCornerTileWidth, 0, *tile->pixmap( TileTopRight ) );
            p.drawTiledPixmap( w - rightCornerTileWidth, upCornerTileHeight, rightCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileRight ) );
            p.drawPixmap( w - rightCornerTileWidth, h - downCornerTileHeight, *tile->pixmap( TileBtmRight ) );

        }
    }

    int ah = rect.height() / 3;
    int aw = ah;
    int ax = rect.width() - aw - 7;
    int ay = ( rect.height() - ah ) / 2;
    // Are we enabled?
    //         if ( widget->isEnabled() )
    //             flags |= Style_Enabled;
    //         // Are we "pushed" ?
    //         if ( active & Style_Sunken )
    //             flags |= Style_Sunken;
    drawPrimitive( PE_ArrowDown, &p, QRect( ax, ay, aw, ah ), group, flags );
    p.end();
    painter->drawPixmap( rect.x(), rect.y(), *tmpBtnPix, 0, 0,
                         rect.width(), rect.height() );
    delete tmpBtnPix;

    if ( hover_ == combo )
        painter->setPen( Qt::white );
    else
        painter->setPen( oldPen );

}

//////////////////////////////////////////////////////////////////////////////
// adjustHSV()
// -----------
//
QPixmap* Metal4kdeStyle::adjustHSV( QImage &img, const QColor &c, bool blend ) const
{
#ifdef BACKTRACE
    qWarning( "adjustHSV()" );
#endif

    QImage * tmp = new QImage();
    tmp = adjustHSVImage( img, c, blend );
    QPixmap *pix = new QPixmap;
    pix->convertFromImage( *tmp );
    delete tmp;
    return ( pix );
}

//////////////////////////////////////////////////////////////////////////////
// adjustHSVImage()
// -----------
//
QImage* Metal4kdeStyle::adjustHSVImage( QImage &img, const QColor &c, bool blend ) const
{
#ifdef BACKTRACE
    qWarning( "adjustHSVImage()" );
#endif

    QColor bgColor = optionsHandler_->customColors_[CustomWidgetBorderColor];
    int colorShift = optionsHandler_->coloringAmount_;
    if(img.width() == 1024 && img.height() == 100)
    {
        colorShift = 20;
    }

    img = img.convertDepth( 32 );
    QImage *dest = new QImage( img.width(), img.height(), 32 );
    dest->setAlphaBuffer( true );
    unsigned int *data = ( unsigned int * ) img.bits();
    unsigned int *destData = ( unsigned int* ) dest->bits();
    int total = img.width() * img.height();
    int current;
    int delta;
    int destR, destG, destB, alpha;
    int srcR = c.red() + colorShift;
    int srcG = c.green() + colorShift;
    int srcB = c.blue() + colorShift;
    float srcPercent, destPercent;
    for ( current = 0; current < total; ++current )
    {
        alpha = qAlpha( data[ current ] );
        delta = 255 - qRed( data[ current ] );
        destR = srcR - delta;
        destG = srcG - delta;
        destB = srcB - delta;
        if ( destR < 0 )
            destR = 0;
        if ( destG < 0 )
            destG = 0;
        if ( destB < 0 )
            destB = 0;
        if ( destR > 255 )
            destR = 255;
        if ( destG > 255 )
            destG = 255;
        if ( destB > 255 )
            destB = 255;

        if ( blend && alpha != 255 && alpha != 0 )
        {
            srcPercent = ( ( float ) alpha ) / 255.0;
            destPercent = 1.0 - srcPercent;
            destR = ( int ) ( ( srcPercent * destR ) + ( destPercent * bgColor.red() ) );
            destG = ( int ) ( ( srcPercent * destG ) + ( destPercent * bgColor.green() ) );
            destB = ( int ) ( ( srcPercent * destB ) + ( destPercent * bgColor.blue() ) );
            alpha = 255;
        }
        destData[ current ] = qRgba( destR, destG, destB, alpha );
    }
    return ( dest );
}

//////////////////////////////////////////////////////////////////////////////
// drawClearBevel()
// -----------
//
void Metal4kdeStyle::drawClearBevel( QPainter *painter, int x, int y, int w, int h, const QColor fillColor , bool isPopUp ) const
{
#ifdef BACKTRACE
    qWarning( "drawClearBevel()" );
#endif

    int leftCornerTileWidth = 5, midTilesWidth = 40, rightCornerTileWidth = 5, upCornerTileHeight = 8, midTilesHeight = 2, downCornerTileHeight = 8;
    QColor fill = fillColor;

    //qWarning( "hegiht - %d", h );

    if ( h > 18 )
    {
        upCornerTileHeight = 16, midTilesHeight = 1, downCornerTileHeight = 10;

    }

    Metal4kdeStyle * ptr = const_cast<Metal4kdeStyle*>( this );

    ButtonTile *tile = h > 18 ? clearFillLargeDict_.find( fill.rgb() ) : clearFillSmallDict_.find( fill.rgb() );

    if ( !tile )
    {
        QPixmap * clearBevelPix = new QPixmap();
        clearBevelPix = adjustHSV( h > 18 ? *clearFillLargeImg_ : *clearFillSmallImg_, fill );

        tile = separateTiles( clearBevelPix, leftCornerTileWidth, midTilesWidth, rightCornerTileWidth, upCornerTileHeight, midTilesHeight, downCornerTileHeight );
        if ( tile )
            h > 18 ? ptr->clearFillLargeDict_.insert( fill.rgb(), tile ) : ptr->clearFillSmallDict_.insert( fill.rgb(), tile );
    }

    if ( !tile )
    {
        //qWarning( "Button tile is NULL!" );
        return ;
    }

    QPixmap *tmpBtnPix = new QPixmap( w, h );

    // prepare the pixmap
    QPainter p;
    p.begin( tmpBtnPix );

    //draw tiled pixmaps_
    drawSeperetedTiles( &p, tile, leftCornerTileWidth, rightCornerTileWidth, upCornerTileHeight, downCornerTileHeight, w, h );

    if ( isPopUp )
    {
        p.drawPixmap( 0, 0, *menuLeftPix_ );
        p.drawPixmap( w - 50, 0, *menuRightPix_ );
    }
    p.end();

    painter->drawPixmap( x, y, *tmpBtnPix, 0, 0, w, h );

    delete tmpBtnPix;
}

//////////////////////////////////////////////////////////////////////////////
// drawSeperetedTiles()
// -----------
//
void Metal4kdeStyle::drawSeperetedTiles( QPainter *p, ButtonTile *tile, int leftCornerTileWidth, int rightCornerTileWidth, int upCornerTileHeight, int downCornerTileHeight, int w, int h ) const
{
#ifdef BACKTRACE
    qWarning( "drawSeperetedTiles()" );
#endif

    // width tiling
    if ( w > ( leftCornerTileWidth + rightCornerTileWidth ) )
    {
        // top
        p->drawTiledPixmap( leftCornerTileWidth, 0, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileTop ) );
        // buttom
        p->drawTiledPixmap( leftCornerTileWidth, h - downCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), upCornerTileHeight, *tile->pixmap( TileBtm ) );
    }
    // height tiling
    if ( h > ( upCornerTileHeight + downCornerTileHeight ) )
    {
        // left
        p->drawTiledPixmap( 0, upCornerTileHeight, leftCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileLeft ) );
        // right
        p->drawTiledPixmap( w - rightCornerTileWidth, upCornerTileHeight, rightCornerTileWidth, h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileRight ) );
    }
    // width and height tiling
    if ( w > ( leftCornerTileWidth + rightCornerTileWidth ) && h > ( upCornerTileHeight + downCornerTileHeight ) )
    { // middle

        p->drawTiledPixmap( leftCornerTileWidth, upCornerTileHeight, w - ( leftCornerTileWidth + rightCornerTileWidth ), h - ( upCornerTileHeight + downCornerTileHeight ), *tile->pixmap( TileMiddle ) );
    }

    // corners
    p->drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
    p->drawPixmap( w - rightCornerTileWidth, 0, *tile->pixmap( TileTopRight ) );
    p->drawPixmap( 0, h - downCornerTileHeight, *tile->pixmap( TileBtmLeft ) );
    p->drawPixmap( w - rightCornerTileWidth, h - downCornerTileHeight, *tile->pixmap( TileBtmRight ) );
}

//////////////////////////////////////////////////////////////////////////////
// drawEditFrame()
// -----------
//
void Metal4kdeStyle::drawEditFrame( QPainter *painter, const QRect &rect, const QColorGroup &group ) const
{
#ifdef BACKTRACE
    qWarning( "drawEditFrame()" );
#endif

    QColor fill( group.background().dark( 105 ) );
    QColor light1( group.background().dark( 115 ) );
    QColor light2( group.background().dark( 120 ) );

    QColor dark1( group.background().dark( 130 ) );
    QColor dark2( group.background().dark( 150 ) );
    QColor dark3( group.background().dark( 200 ) );


    painter->setPen( light2 );
    painter->drawLine( rect.x(), rect.y(), rect.right(), rect.y() );
    painter->drawLine( rect.x(), rect.y(), rect.x(), rect.bottom() );
    painter->setPen( dark1 );
    painter->drawLine( rect.x(), rect.bottom(), rect.right(), rect.bottom() );
    painter->drawLine( rect.right(), rect.y(), rect.right(), rect.bottom() );

    // inner rect
    painter->setPen( dark2 );
    painter->drawPoint( rect.x() + 1, rect.y() + 1 );
    painter->drawPoint( rect.x() + 1, rect.bottom() - 1 );
    painter->drawPoint( rect.right() - 1, rect.y() + 1 );
    painter->drawPoint( rect.right() - 1, rect.bottom() - 1 );
    painter->setPen( dark3 );
    painter->drawLine( rect.x() + 2, rect.y() + 1, rect.right() - 2, rect.y() + 1 );
    painter->drawLine( rect.x() + 2, rect.bottom() - 1, rect.right() - 2, rect.bottom() - 1 );
    painter->drawLine( rect.x() + 1, rect.y() + 2, rect.x() + 1, rect.bottom() - 2 );
    painter->drawLine( rect.right() - 1, rect.y() + 2, rect.right() - 1, rect.bottom() - 2 );
}


//////////////////////////////////////////////////////////////////////////////
// isHTMLWidget()
// -----------
//
bool Metal4kdeStyle::isHTMLWidget( const QWidget *widget ) const
{
#ifdef BACKTRACE
    qWarning( "isHTMLWidget()" );
#endif

    const QObject * w = widget->parent();
    if ( w )
    {
        if ( !w->inherits( "QClipperWidget" ) )
            return ( false );
        w = w->parent();
        if ( w )
        {
            w = w->parent();
            if ( w && w->inherits( "KHTMLView" ) )
                return ( true );
        }
    }
    return ( false );
}


